/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AlertConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#enabled AlertConfiguration#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#event_type AlertConfiguration#event_type}
    */
    readonly eventType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#project_id AlertConfiguration#project_id}
    */
    readonly projectId: string;
    /**
    * matcher block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#matcher AlertConfiguration#matcher}
    */
    readonly matcher?: AlertConfigurationMatcher[] | cdktf.IResolvable;
    /**
    * metric_threshold_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#metric_threshold_config AlertConfiguration#metric_threshold_config}
    */
    readonly metricThresholdConfig?: AlertConfigurationMetricThresholdConfig[] | cdktf.IResolvable;
    /**
    * notification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#notification AlertConfiguration#notification}
    */
    readonly notification?: AlertConfigurationNotification[] | cdktf.IResolvable;
    /**
    * threshold_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#threshold_config AlertConfiguration#threshold_config}
    */
    readonly thresholdConfig?: AlertConfigurationThresholdConfig[] | cdktf.IResolvable;
}
export interface AlertConfigurationMatcher {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#field_name AlertConfiguration#field_name}
    */
    readonly fieldName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#operator AlertConfiguration#operator}
    */
    readonly operator: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#value AlertConfiguration#value}
    */
    readonly value: string;
}
export declare function alertConfigurationMatcherToTerraform(struct?: AlertConfigurationMatcher | cdktf.IResolvable): any;
export declare function alertConfigurationMatcherToHclTerraform(struct?: AlertConfigurationMatcher | cdktf.IResolvable): any;
export declare class AlertConfigurationMatcherOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlertConfigurationMatcher | cdktf.IResolvable | undefined;
    set internalValue(value: AlertConfigurationMatcher | cdktf.IResolvable | undefined);
    private _fieldName?;
    get fieldName(): string;
    set fieldName(value: string);
    get fieldNameInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    get operatorInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class AlertConfigurationMatcherList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlertConfigurationMatcher[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlertConfigurationMatcherOutputReference;
}
export interface AlertConfigurationMetricThresholdConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#metric_name AlertConfiguration#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#mode AlertConfiguration#mode}
    */
    readonly mode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#operator AlertConfiguration#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#threshold AlertConfiguration#threshold}
    */
    readonly threshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#units AlertConfiguration#units}
    */
    readonly units?: string;
}
export declare function alertConfigurationMetricThresholdConfigToTerraform(struct?: AlertConfigurationMetricThresholdConfig | cdktf.IResolvable): any;
export declare function alertConfigurationMetricThresholdConfigToHclTerraform(struct?: AlertConfigurationMetricThresholdConfig | cdktf.IResolvable): any;
export declare class AlertConfigurationMetricThresholdConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlertConfigurationMetricThresholdConfig | cdktf.IResolvable | undefined;
    set internalValue(value: AlertConfigurationMetricThresholdConfig | cdktf.IResolvable | undefined);
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _mode?;
    get mode(): string;
    set mode(value: string);
    resetMode(): void;
    get modeInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    resetThreshold(): void;
    get thresholdInput(): number | undefined;
    private _units?;
    get units(): string;
    set units(value: string);
    resetUnits(): void;
    get unitsInput(): string | undefined;
}
export declare class AlertConfigurationMetricThresholdConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlertConfigurationMetricThresholdConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlertConfigurationMetricThresholdConfigOutputReference;
}
export interface AlertConfigurationNotification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#api_token AlertConfiguration#api_token}
    */
    readonly apiToken?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#channel_name AlertConfiguration#channel_name}
    */
    readonly channelName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#datadog_api_key AlertConfiguration#datadog_api_key}
    */
    readonly datadogApiKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#datadog_region AlertConfiguration#datadog_region}
    */
    readonly datadogRegion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#delay_min AlertConfiguration#delay_min}
    */
    readonly delayMin?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#email_address AlertConfiguration#email_address}
    */
    readonly emailAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#email_enabled AlertConfiguration#email_enabled}
    */
    readonly emailEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#integration_id AlertConfiguration#integration_id}
    */
    readonly integrationId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#interval_min AlertConfiguration#interval_min}
    */
    readonly intervalMin?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#microsoft_teams_webhook_url AlertConfiguration#microsoft_teams_webhook_url}
    */
    readonly microsoftTeamsWebhookUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#mobile_number AlertConfiguration#mobile_number}
    */
    readonly mobileNumber?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#notifier_id AlertConfiguration#notifier_id}
    */
    readonly notifierId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#ops_genie_api_key AlertConfiguration#ops_genie_api_key}
    */
    readonly opsGenieApiKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#ops_genie_region AlertConfiguration#ops_genie_region}
    */
    readonly opsGenieRegion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#roles AlertConfiguration#roles}
    */
    readonly roles?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#service_key AlertConfiguration#service_key}
    */
    readonly serviceKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#sms_enabled AlertConfiguration#sms_enabled}
    */
    readonly smsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#team_id AlertConfiguration#team_id}
    */
    readonly teamId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#type_name AlertConfiguration#type_name}
    */
    readonly typeName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#username AlertConfiguration#username}
    */
    readonly username?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#victor_ops_api_key AlertConfiguration#victor_ops_api_key}
    */
    readonly victorOpsApiKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#victor_ops_routing_key AlertConfiguration#victor_ops_routing_key}
    */
    readonly victorOpsRoutingKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#webhook_secret AlertConfiguration#webhook_secret}
    */
    readonly webhookSecret?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#webhook_url AlertConfiguration#webhook_url}
    */
    readonly webhookUrl?: string;
}
export declare function alertConfigurationNotificationToTerraform(struct?: AlertConfigurationNotification | cdktf.IResolvable): any;
export declare function alertConfigurationNotificationToHclTerraform(struct?: AlertConfigurationNotification | cdktf.IResolvable): any;
export declare class AlertConfigurationNotificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlertConfigurationNotification | cdktf.IResolvable | undefined;
    set internalValue(value: AlertConfigurationNotification | cdktf.IResolvable | undefined);
    private _apiToken?;
    get apiToken(): string;
    set apiToken(value: string);
    resetApiToken(): void;
    get apiTokenInput(): string | undefined;
    private _channelName?;
    get channelName(): string;
    set channelName(value: string);
    resetChannelName(): void;
    get channelNameInput(): string | undefined;
    private _datadogApiKey?;
    get datadogApiKey(): string;
    set datadogApiKey(value: string);
    resetDatadogApiKey(): void;
    get datadogApiKeyInput(): string | undefined;
    private _datadogRegion?;
    get datadogRegion(): string;
    set datadogRegion(value: string);
    resetDatadogRegion(): void;
    get datadogRegionInput(): string | undefined;
    private _delayMin?;
    get delayMin(): number;
    set delayMin(value: number);
    resetDelayMin(): void;
    get delayMinInput(): number | undefined;
    private _emailAddress?;
    get emailAddress(): string;
    set emailAddress(value: string);
    resetEmailAddress(): void;
    get emailAddressInput(): string | undefined;
    private _emailEnabled?;
    get emailEnabled(): boolean | cdktf.IResolvable;
    set emailEnabled(value: boolean | cdktf.IResolvable);
    resetEmailEnabled(): void;
    get emailEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _integrationId?;
    get integrationId(): string;
    set integrationId(value: string);
    resetIntegrationId(): void;
    get integrationIdInput(): string | undefined;
    private _intervalMin?;
    get intervalMin(): number;
    set intervalMin(value: number);
    resetIntervalMin(): void;
    get intervalMinInput(): number | undefined;
    private _microsoftTeamsWebhookUrl?;
    get microsoftTeamsWebhookUrl(): string;
    set microsoftTeamsWebhookUrl(value: string);
    resetMicrosoftTeamsWebhookUrl(): void;
    get microsoftTeamsWebhookUrlInput(): string | undefined;
    private _mobileNumber?;
    get mobileNumber(): string;
    set mobileNumber(value: string);
    resetMobileNumber(): void;
    get mobileNumberInput(): string | undefined;
    private _notifierId?;
    get notifierId(): string;
    set notifierId(value: string);
    resetNotifierId(): void;
    get notifierIdInput(): string | undefined;
    private _opsGenieApiKey?;
    get opsGenieApiKey(): string;
    set opsGenieApiKey(value: string);
    resetOpsGenieApiKey(): void;
    get opsGenieApiKeyInput(): string | undefined;
    private _opsGenieRegion?;
    get opsGenieRegion(): string;
    set opsGenieRegion(value: string);
    resetOpsGenieRegion(): void;
    get opsGenieRegionInput(): string | undefined;
    private _roles?;
    get roles(): string[];
    set roles(value: string[]);
    resetRoles(): void;
    get rolesInput(): string[] | undefined;
    private _serviceKey?;
    get serviceKey(): string;
    set serviceKey(value: string);
    resetServiceKey(): void;
    get serviceKeyInput(): string | undefined;
    private _smsEnabled?;
    get smsEnabled(): boolean | cdktf.IResolvable;
    set smsEnabled(value: boolean | cdktf.IResolvable);
    resetSmsEnabled(): void;
    get smsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _teamId?;
    get teamId(): string;
    set teamId(value: string);
    resetTeamId(): void;
    get teamIdInput(): string | undefined;
    get teamName(): string;
    private _typeName?;
    get typeName(): string;
    set typeName(value: string);
    get typeNameInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    private _victorOpsApiKey?;
    get victorOpsApiKey(): string;
    set victorOpsApiKey(value: string);
    resetVictorOpsApiKey(): void;
    get victorOpsApiKeyInput(): string | undefined;
    private _victorOpsRoutingKey?;
    get victorOpsRoutingKey(): string;
    set victorOpsRoutingKey(value: string);
    resetVictorOpsRoutingKey(): void;
    get victorOpsRoutingKeyInput(): string | undefined;
    private _webhookSecret?;
    get webhookSecret(): string;
    set webhookSecret(value: string);
    resetWebhookSecret(): void;
    get webhookSecretInput(): string | undefined;
    private _webhookUrl?;
    get webhookUrl(): string;
    set webhookUrl(value: string);
    resetWebhookUrl(): void;
    get webhookUrlInput(): string | undefined;
}
export declare class AlertConfigurationNotificationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlertConfigurationNotification[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlertConfigurationNotificationOutputReference;
}
export interface AlertConfigurationThresholdConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#operator AlertConfiguration#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#threshold AlertConfiguration#threshold}
    */
    readonly threshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#units AlertConfiguration#units}
    */
    readonly units?: string;
}
export declare function alertConfigurationThresholdConfigToTerraform(struct?: AlertConfigurationThresholdConfig | cdktf.IResolvable): any;
export declare function alertConfigurationThresholdConfigToHclTerraform(struct?: AlertConfigurationThresholdConfig | cdktf.IResolvable): any;
export declare class AlertConfigurationThresholdConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): AlertConfigurationThresholdConfig | cdktf.IResolvable | undefined;
    set internalValue(value: AlertConfigurationThresholdConfig | cdktf.IResolvable | undefined);
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    resetThreshold(): void;
    get thresholdInput(): number | undefined;
    private _units?;
    get units(): string;
    set units(value: string);
    resetUnits(): void;
    get unitsInput(): string | undefined;
}
export declare class AlertConfigurationThresholdConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: AlertConfigurationThresholdConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): AlertConfigurationThresholdConfigOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration mongodbatlas_alert_configuration}
*/
export declare class AlertConfiguration extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_alert_configuration";
    /**
    * Generates CDKTF code for importing a AlertConfiguration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the AlertConfiguration to import
    * @param importFromId The id of the existing AlertConfiguration that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the AlertConfiguration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/alert_configuration mongodbatlas_alert_configuration} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AlertConfigurationConfig
    */
    constructor(scope: Construct, id: string, config: AlertConfigurationConfig);
    get alertConfigurationId(): string;
    get created(): string;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _eventType?;
    get eventType(): string;
    set eventType(value: string);
    get eventTypeInput(): string | undefined;
    get id(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get updated(): string;
    private _matcher;
    get matcher(): AlertConfigurationMatcherList;
    putMatcher(value: AlertConfigurationMatcher[] | cdktf.IResolvable): void;
    resetMatcher(): void;
    get matcherInput(): cdktf.IResolvable | AlertConfigurationMatcher[] | undefined;
    private _metricThresholdConfig;
    get metricThresholdConfig(): AlertConfigurationMetricThresholdConfigList;
    putMetricThresholdConfig(value: AlertConfigurationMetricThresholdConfig[] | cdktf.IResolvable): void;
    resetMetricThresholdConfig(): void;
    get metricThresholdConfigInput(): cdktf.IResolvable | AlertConfigurationMetricThresholdConfig[] | undefined;
    private _notification;
    get notification(): AlertConfigurationNotificationList;
    putNotification(value: AlertConfigurationNotification[] | cdktf.IResolvable): void;
    resetNotification(): void;
    get notificationInput(): cdktf.IResolvable | AlertConfigurationNotification[] | undefined;
    private _thresholdConfig;
    get thresholdConfig(): AlertConfigurationThresholdConfigList;
    putThresholdConfig(value: AlertConfigurationThresholdConfig[] | cdktf.IResolvable): void;
    resetThresholdConfig(): void;
    get thresholdConfigInput(): cdktf.IResolvable | AlertConfigurationThresholdConfig[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
