/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface AuditingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#audit_authorization_success Auditing#audit_authorization_success}
    */
    readonly auditAuthorizationSuccess?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#audit_filter Auditing#audit_filter}
    */
    readonly auditFilter?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#enabled Auditing#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#id Auditing#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#project_id Auditing#project_id}
    */
    readonly projectId: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing mongodbatlas_auditing}
*/
export declare class Auditing extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_auditing";
    /**
    * Generates CDKTF code for importing a Auditing resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the Auditing to import
    * @param importFromId The id of the existing Auditing that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the Auditing to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/auditing mongodbatlas_auditing} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options AuditingConfig
    */
    constructor(scope: Construct, id: string, config: AuditingConfig);
    private _auditAuthorizationSuccess?;
    get auditAuthorizationSuccess(): boolean | cdktf.IResolvable;
    set auditAuthorizationSuccess(value: boolean | cdktf.IResolvable);
    resetAuditAuthorizationSuccess(): void;
    get auditAuthorizationSuccessInput(): boolean | cdktf.IResolvable | undefined;
    private _auditFilter?;
    get auditFilter(): string;
    set auditFilter(value: string);
    resetAuditFilter(): void;
    get auditFilterInput(): string | undefined;
    get configurationType(): string;
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
