/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface BackupCompliancePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#authorized_email BackupCompliancePolicy#authorized_email}
    */
    readonly authorizedEmail: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#authorized_user_first_name BackupCompliancePolicy#authorized_user_first_name}
    */
    readonly authorizedUserFirstName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#authorized_user_last_name BackupCompliancePolicy#authorized_user_last_name}
    */
    readonly authorizedUserLastName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#copy_protection_enabled BackupCompliancePolicy#copy_protection_enabled}
    */
    readonly copyProtectionEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#encryption_at_rest_enabled BackupCompliancePolicy#encryption_at_rest_enabled}
    */
    readonly encryptionAtRestEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#id BackupCompliancePolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#pit_enabled BackupCompliancePolicy#pit_enabled}
    */
    readonly pitEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#project_id BackupCompliancePolicy#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#restore_window_days BackupCompliancePolicy#restore_window_days}
    */
    readonly restoreWindowDays?: number;
    /**
    * on_demand_policy_item block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#on_demand_policy_item BackupCompliancePolicy#on_demand_policy_item}
    */
    readonly onDemandPolicyItem: BackupCompliancePolicyOnDemandPolicyItem;
    /**
    * policy_item_daily block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#policy_item_daily BackupCompliancePolicy#policy_item_daily}
    */
    readonly policyItemDaily?: BackupCompliancePolicyPolicyItemDaily;
    /**
    * policy_item_hourly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#policy_item_hourly BackupCompliancePolicy#policy_item_hourly}
    */
    readonly policyItemHourly?: BackupCompliancePolicyPolicyItemHourly;
    /**
    * policy_item_monthly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#policy_item_monthly BackupCompliancePolicy#policy_item_monthly}
    */
    readonly policyItemMonthly?: BackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable;
    /**
    * policy_item_weekly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#policy_item_weekly BackupCompliancePolicy#policy_item_weekly}
    */
    readonly policyItemWeekly?: BackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable;
    /**
    * policy_item_yearly block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#policy_item_yearly BackupCompliancePolicy#policy_item_yearly}
    */
    readonly policyItemYearly?: BackupCompliancePolicyPolicyItemYearly[] | cdktf.IResolvable;
}
export interface BackupCompliancePolicyOnDemandPolicyItem {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyOnDemandPolicyItemToTerraform(struct?: BackupCompliancePolicyOnDemandPolicyItemOutputReference | BackupCompliancePolicyOnDemandPolicyItem): any;
export declare function backupCompliancePolicyOnDemandPolicyItemToHclTerraform(struct?: BackupCompliancePolicyOnDemandPolicyItemOutputReference | BackupCompliancePolicyOnDemandPolicyItem): any;
export declare class BackupCompliancePolicyOnDemandPolicyItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BackupCompliancePolicyOnDemandPolicyItem | undefined;
    set internalValue(value: BackupCompliancePolicyOnDemandPolicyItem | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export interface BackupCompliancePolicyPolicyItemDaily {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyPolicyItemDailyToTerraform(struct?: BackupCompliancePolicyPolicyItemDailyOutputReference | BackupCompliancePolicyPolicyItemDaily): any;
export declare function backupCompliancePolicyPolicyItemDailyToHclTerraform(struct?: BackupCompliancePolicyPolicyItemDailyOutputReference | BackupCompliancePolicyPolicyItemDaily): any;
export declare class BackupCompliancePolicyPolicyItemDailyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BackupCompliancePolicyPolicyItemDaily | undefined;
    set internalValue(value: BackupCompliancePolicyPolicyItemDaily | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export interface BackupCompliancePolicyPolicyItemHourly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyPolicyItemHourlyToTerraform(struct?: BackupCompliancePolicyPolicyItemHourlyOutputReference | BackupCompliancePolicyPolicyItemHourly): any;
export declare function backupCompliancePolicyPolicyItemHourlyToHclTerraform(struct?: BackupCompliancePolicyPolicyItemHourlyOutputReference | BackupCompliancePolicyPolicyItemHourly): any;
export declare class BackupCompliancePolicyPolicyItemHourlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): BackupCompliancePolicyPolicyItemHourly | undefined;
    set internalValue(value: BackupCompliancePolicyPolicyItemHourly | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export interface BackupCompliancePolicyPolicyItemMonthly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyPolicyItemMonthlyToTerraform(struct?: BackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable): any;
export declare function backupCompliancePolicyPolicyItemMonthlyToHclTerraform(struct?: BackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable): any;
export declare class BackupCompliancePolicyPolicyItemMonthlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable | undefined;
    set internalValue(value: BackupCompliancePolicyPolicyItemMonthly | cdktf.IResolvable | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export declare class BackupCompliancePolicyPolicyItemMonthlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: BackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BackupCompliancePolicyPolicyItemMonthlyOutputReference;
}
export interface BackupCompliancePolicyPolicyItemWeekly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyPolicyItemWeeklyToTerraform(struct?: BackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable): any;
export declare function backupCompliancePolicyPolicyItemWeeklyToHclTerraform(struct?: BackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable): any;
export declare class BackupCompliancePolicyPolicyItemWeeklyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable | undefined;
    set internalValue(value: BackupCompliancePolicyPolicyItemWeekly | cdktf.IResolvable | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export declare class BackupCompliancePolicyPolicyItemWeeklyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: BackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BackupCompliancePolicyPolicyItemWeeklyOutputReference;
}
export interface BackupCompliancePolicyPolicyItemYearly {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#frequency_interval BackupCompliancePolicy#frequency_interval}
    */
    readonly frequencyInterval: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_unit BackupCompliancePolicy#retention_unit}
    */
    readonly retentionUnit: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#retention_value BackupCompliancePolicy#retention_value}
    */
    readonly retentionValue: number;
}
export declare function backupCompliancePolicyPolicyItemYearlyToTerraform(struct?: BackupCompliancePolicyPolicyItemYearly | cdktf.IResolvable): any;
export declare function backupCompliancePolicyPolicyItemYearlyToHclTerraform(struct?: BackupCompliancePolicyPolicyItemYearly | cdktf.IResolvable): any;
export declare class BackupCompliancePolicyPolicyItemYearlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): BackupCompliancePolicyPolicyItemYearly | cdktf.IResolvable | undefined;
    set internalValue(value: BackupCompliancePolicyPolicyItemYearly | cdktf.IResolvable | undefined);
    private _frequencyInterval?;
    get frequencyInterval(): number;
    set frequencyInterval(value: number);
    get frequencyIntervalInput(): number | undefined;
    get frequencyType(): string;
    get id(): string;
    private _retentionUnit?;
    get retentionUnit(): string;
    set retentionUnit(value: string);
    get retentionUnitInput(): string | undefined;
    private _retentionValue?;
    get retentionValue(): number;
    set retentionValue(value: number);
    get retentionValueInput(): number | undefined;
}
export declare class BackupCompliancePolicyPolicyItemYearlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: BackupCompliancePolicyPolicyItemYearly[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): BackupCompliancePolicyPolicyItemYearlyOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy mongodbatlas_backup_compliance_policy}
*/
export declare class BackupCompliancePolicy extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_backup_compliance_policy";
    /**
    * Generates CDKTF code for importing a BackupCompliancePolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the BackupCompliancePolicy to import
    * @param importFromId The id of the existing BackupCompliancePolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the BackupCompliancePolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/backup_compliance_policy mongodbatlas_backup_compliance_policy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options BackupCompliancePolicyConfig
    */
    constructor(scope: Construct, id: string, config: BackupCompliancePolicyConfig);
    private _authorizedEmail?;
    get authorizedEmail(): string;
    set authorizedEmail(value: string);
    get authorizedEmailInput(): string | undefined;
    private _authorizedUserFirstName?;
    get authorizedUserFirstName(): string;
    set authorizedUserFirstName(value: string);
    get authorizedUserFirstNameInput(): string | undefined;
    private _authorizedUserLastName?;
    get authorizedUserLastName(): string;
    set authorizedUserLastName(value: string);
    get authorizedUserLastNameInput(): string | undefined;
    private _copyProtectionEnabled?;
    get copyProtectionEnabled(): boolean | cdktf.IResolvable;
    set copyProtectionEnabled(value: boolean | cdktf.IResolvable);
    resetCopyProtectionEnabled(): void;
    get copyProtectionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionAtRestEnabled?;
    get encryptionAtRestEnabled(): boolean | cdktf.IResolvable;
    set encryptionAtRestEnabled(value: boolean | cdktf.IResolvable);
    resetEncryptionAtRestEnabled(): void;
    get encryptionAtRestEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _pitEnabled?;
    get pitEnabled(): boolean | cdktf.IResolvable;
    set pitEnabled(value: boolean | cdktf.IResolvable);
    resetPitEnabled(): void;
    get pitEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _restoreWindowDays?;
    get restoreWindowDays(): number;
    set restoreWindowDays(value: number);
    resetRestoreWindowDays(): void;
    get restoreWindowDaysInput(): number | undefined;
    get state(): string;
    get updatedDate(): string;
    get updatedUser(): string;
    private _onDemandPolicyItem;
    get onDemandPolicyItem(): BackupCompliancePolicyOnDemandPolicyItemOutputReference;
    putOnDemandPolicyItem(value: BackupCompliancePolicyOnDemandPolicyItem): void;
    get onDemandPolicyItemInput(): BackupCompliancePolicyOnDemandPolicyItem | undefined;
    private _policyItemDaily;
    get policyItemDaily(): BackupCompliancePolicyPolicyItemDailyOutputReference;
    putPolicyItemDaily(value: BackupCompliancePolicyPolicyItemDaily): void;
    resetPolicyItemDaily(): void;
    get policyItemDailyInput(): BackupCompliancePolicyPolicyItemDaily | undefined;
    private _policyItemHourly;
    get policyItemHourly(): BackupCompliancePolicyPolicyItemHourlyOutputReference;
    putPolicyItemHourly(value: BackupCompliancePolicyPolicyItemHourly): void;
    resetPolicyItemHourly(): void;
    get policyItemHourlyInput(): BackupCompliancePolicyPolicyItemHourly | undefined;
    private _policyItemMonthly;
    get policyItemMonthly(): BackupCompliancePolicyPolicyItemMonthlyList;
    putPolicyItemMonthly(value: BackupCompliancePolicyPolicyItemMonthly[] | cdktf.IResolvable): void;
    resetPolicyItemMonthly(): void;
    get policyItemMonthlyInput(): cdktf.IResolvable | BackupCompliancePolicyPolicyItemMonthly[] | undefined;
    private _policyItemWeekly;
    get policyItemWeekly(): BackupCompliancePolicyPolicyItemWeeklyList;
    putPolicyItemWeekly(value: BackupCompliancePolicyPolicyItemWeekly[] | cdktf.IResolvable): void;
    resetPolicyItemWeekly(): void;
    get policyItemWeeklyInput(): cdktf.IResolvable | BackupCompliancePolicyPolicyItemWeekly[] | undefined;
    private _policyItemYearly;
    get policyItemYearly(): BackupCompliancePolicyPolicyItemYearlyList;
    putPolicyItemYearly(value: BackupCompliancePolicyPolicyItemYearly[] | cdktf.IResolvable): void;
    resetPolicyItemYearly(): void;
    get policyItemYearlyInput(): cdktf.IResolvable | BackupCompliancePolicyPolicyItemYearly[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
