/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataLakePipelineConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#name DataLakePipeline#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#project_id DataLakePipeline#project_id}
    */
    readonly projectId: string;
    /**
    * sink block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#sink DataLakePipeline#sink}
    */
    readonly sink?: DataLakePipelineSink;
    /**
    * source block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#source DataLakePipeline#source}
    */
    readonly source?: DataLakePipelineSource;
    /**
    * transformations block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#transformations DataLakePipeline#transformations}
    */
    readonly transformations?: DataLakePipelineTransformations[] | cdktf.IResolvable;
}
export interface DataLakePipelineIngestionSchedules {
}
export declare function dataLakePipelineIngestionSchedulesToTerraform(struct?: DataLakePipelineIngestionSchedules): any;
export declare function dataLakePipelineIngestionSchedulesToHclTerraform(struct?: DataLakePipelineIngestionSchedules): any;
export declare class DataLakePipelineIngestionSchedulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataLakePipelineIngestionSchedules | undefined;
    set internalValue(value: DataLakePipelineIngestionSchedules | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataLakePipelineIngestionSchedulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataLakePipelineIngestionSchedulesOutputReference;
}
export interface DataLakePipelineSnapshots {
}
export declare function dataLakePipelineSnapshotsToTerraform(struct?: DataLakePipelineSnapshots): any;
export declare function dataLakePipelineSnapshotsToHclTerraform(struct?: DataLakePipelineSnapshots): any;
export declare class DataLakePipelineSnapshotsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataLakePipelineSnapshots | undefined;
    set internalValue(value: DataLakePipelineSnapshots | undefined);
    get copyRegion(): string;
    get createdAt(): string;
    get expiresAt(): string;
    get frequencyYype(): string;
    get id(): string;
    get masterKey(): string;
    get mongodVersion(): string;
    get policies(): string[];
    get provider(): string;
    get replicaSetName(): string;
    get size(): number;
    get snapshotType(): string;
    get status(): string;
    get type(): string;
}
export declare class DataLakePipelineSnapshotsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataLakePipelineSnapshotsOutputReference;
}
export interface DataLakePipelineSinkPartitionFields {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#field_name DataLakePipeline#field_name}
    */
    readonly fieldName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#order DataLakePipeline#order}
    */
    readonly order: number;
}
export declare function dataLakePipelineSinkPartitionFieldsToTerraform(struct?: DataLakePipelineSinkPartitionFields | cdktf.IResolvable): any;
export declare function dataLakePipelineSinkPartitionFieldsToHclTerraform(struct?: DataLakePipelineSinkPartitionFields | cdktf.IResolvable): any;
export declare class DataLakePipelineSinkPartitionFieldsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataLakePipelineSinkPartitionFields | cdktf.IResolvable | undefined;
    set internalValue(value: DataLakePipelineSinkPartitionFields | cdktf.IResolvable | undefined);
    private _fieldName?;
    get fieldName(): string;
    set fieldName(value: string);
    get fieldNameInput(): string | undefined;
    private _order?;
    get order(): number;
    set order(value: number);
    get orderInput(): number | undefined;
}
export declare class DataLakePipelineSinkPartitionFieldsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataLakePipelineSinkPartitionFields[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataLakePipelineSinkPartitionFieldsOutputReference;
}
export interface DataLakePipelineSink {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#provider DataLakePipeline#provider}
    */
    readonly provider?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#region DataLakePipeline#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#type DataLakePipeline#type}
    */
    readonly type?: string;
    /**
    * partition_fields block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#partition_fields DataLakePipeline#partition_fields}
    */
    readonly partitionFields?: DataLakePipelineSinkPartitionFields[] | cdktf.IResolvable;
}
export declare function dataLakePipelineSinkToTerraform(struct?: DataLakePipelineSinkOutputReference | DataLakePipelineSink): any;
export declare function dataLakePipelineSinkToHclTerraform(struct?: DataLakePipelineSinkOutputReference | DataLakePipelineSink): any;
export declare class DataLakePipelineSinkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataLakePipelineSink | undefined;
    set internalValue(value: DataLakePipelineSink | undefined);
    private _provider?;
    get provider(): string;
    set provider(value: string);
    resetProvider(): void;
    get providerInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _partitionFields;
    get partitionFields(): DataLakePipelineSinkPartitionFieldsList;
    putPartitionFields(value: DataLakePipelineSinkPartitionFields[] | cdktf.IResolvable): void;
    resetPartitionFields(): void;
    get partitionFieldsInput(): cdktf.IResolvable | DataLakePipelineSinkPartitionFields[] | undefined;
}
export interface DataLakePipelineSource {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#cluster_name DataLakePipeline#cluster_name}
    */
    readonly clusterName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#collection_name DataLakePipeline#collection_name}
    */
    readonly collectionName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#database_name DataLakePipeline#database_name}
    */
    readonly databaseName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#policy_item_id DataLakePipeline#policy_item_id}
    */
    readonly policyItemId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#project_id DataLakePipeline#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#type DataLakePipeline#type}
    */
    readonly type?: string;
}
export declare function dataLakePipelineSourceToTerraform(struct?: DataLakePipelineSourceOutputReference | DataLakePipelineSource): any;
export declare function dataLakePipelineSourceToHclTerraform(struct?: DataLakePipelineSourceOutputReference | DataLakePipelineSource): any;
export declare class DataLakePipelineSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataLakePipelineSource | undefined;
    set internalValue(value: DataLakePipelineSource | undefined);
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    resetClusterName(): void;
    get clusterNameInput(): string | undefined;
    private _collectionName?;
    get collectionName(): string;
    set collectionName(value: string);
    resetCollectionName(): void;
    get collectionNameInput(): string | undefined;
    private _databaseName?;
    get databaseName(): string;
    set databaseName(value: string);
    resetDatabaseName(): void;
    get databaseNameInput(): string | undefined;
    private _policyItemId?;
    get policyItemId(): string;
    set policyItemId(value: string);
    resetPolicyItemId(): void;
    get policyItemIdInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface DataLakePipelineTransformations {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#field DataLakePipeline#field}
    */
    readonly field?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#type DataLakePipeline#type}
    */
    readonly type?: string;
}
export declare function dataLakePipelineTransformationsToTerraform(struct?: DataLakePipelineTransformations | cdktf.IResolvable): any;
export declare function dataLakePipelineTransformationsToHclTerraform(struct?: DataLakePipelineTransformations | cdktf.IResolvable): any;
export declare class DataLakePipelineTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataLakePipelineTransformations | cdktf.IResolvable | undefined;
    set internalValue(value: DataLakePipelineTransformations | cdktf.IResolvable | undefined);
    private _field?;
    get field(): string;
    set field(value: string);
    resetField(): void;
    get fieldInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export declare class DataLakePipelineTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataLakePipelineTransformations[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataLakePipelineTransformationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline mongodbatlas_data_lake_pipeline}
*/
export declare class DataLakePipeline extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_data_lake_pipeline";
    /**
    * Generates CDKTF code for importing a DataLakePipeline resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataLakePipeline to import
    * @param importFromId The id of the existing DataLakePipeline that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataLakePipeline to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/data_lake_pipeline mongodbatlas_data_lake_pipeline} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataLakePipelineConfig
    */
    constructor(scope: Construct, id: string, config: DataLakePipelineConfig);
    get createdDate(): string;
    get id(): string;
    private _ingestionSchedules;
    get ingestionSchedules(): DataLakePipelineIngestionSchedulesList;
    get lastUpdatedDate(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _snapshots;
    get snapshots(): DataLakePipelineSnapshotsList;
    get state(): string;
    private _sink;
    get sink(): DataLakePipelineSinkOutputReference;
    putSink(value: DataLakePipelineSink): void;
    resetSink(): void;
    get sinkInput(): DataLakePipelineSink | undefined;
    private _source;
    get source(): DataLakePipelineSourceOutputReference;
    putSource(value: DataLakePipelineSource): void;
    resetSource(): void;
    get sourceInput(): DataLakePipelineSource | undefined;
    private _transformations;
    get transformations(): DataLakePipelineTransformationsList;
    putTransformations(value: DataLakePipelineTransformations[] | cdktf.IResolvable): void;
    resetTransformations(): void;
    get transformationsInput(): cdktf.IResolvable | DataLakePipelineTransformations[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
