/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasAdvancedClustersConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters#id DataMongodbatlasAdvancedClusters#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters#project_id DataMongodbatlasAdvancedClusters#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters#use_replication_spec_per_shard DataMongodbatlasAdvancedClusters#use_replication_spec_per_shard}
    */
    readonly useReplicationSpecPerShard?: boolean | cdktf.IResolvable;
}
export interface DataMongodbatlasAdvancedClustersResultsAdvancedConfiguration {
}
export declare function dataMongodbatlasAdvancedClustersResultsAdvancedConfigurationToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsAdvancedConfiguration): any;
export declare function dataMongodbatlasAdvancedClustersResultsAdvancedConfigurationToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsAdvancedConfiguration): any;
export declare class DataMongodbatlasAdvancedClustersResultsAdvancedConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsAdvancedConfiguration | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsAdvancedConfiguration | undefined);
    get changeStreamOptionsPreAndPostImagesExpireAfterSeconds(): number;
    get defaultReadConcern(): string;
    get defaultWriteConcern(): string;
    get failIndexKeyTooLong(): cdktf.IResolvable;
    get javascriptEnabled(): cdktf.IResolvable;
    get minimumEnabledTlsProtocol(): string;
    get noTableScan(): cdktf.IResolvable;
    get oplogMinRetentionHours(): number;
    get oplogSizeMb(): number;
    get sampleRefreshIntervalBiConnector(): number;
    get sampleSizeBiConnector(): number;
    get transactionLifetimeLimitSeconds(): number;
}
export declare class DataMongodbatlasAdvancedClustersResultsAdvancedConfigurationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsAdvancedConfigurationOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsBiConnectorConfig {
}
export declare function dataMongodbatlasAdvancedClustersResultsBiConnectorConfigToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsBiConnectorConfig): any;
export declare function dataMongodbatlasAdvancedClustersResultsBiConnectorConfigToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsBiConnectorConfig): any;
export declare class DataMongodbatlasAdvancedClustersResultsBiConnectorConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsBiConnectorConfig | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsBiConnectorConfig | undefined);
    get enabled(): cdktf.IResolvable;
    get readPreference(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsBiConnectorConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsBiConnectorConfigOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpoints {
}
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpoints): any;
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpoints): any;
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpoints | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpoints | undefined);
    get endpointId(): string;
    get providerName(): string;
    get region(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpoint {
}
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpoint): any;
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpoint): any;
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpoint | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpoint | undefined);
    get connectionString(): string;
    private _endpoints;
    get endpoints(): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointEndpointsList;
    get srvConnectionString(): string;
    get srvShardOptimizedConnectionString(): string;
    get type(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsConnectionStrings {
}
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStrings): any;
export declare function dataMongodbatlasAdvancedClustersResultsConnectionStringsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsConnectionStrings): any;
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsConnectionStrings | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsConnectionStrings | undefined);
    get private(): string;
    private _privateEndpoint;
    get privateEndpoint(): DataMongodbatlasAdvancedClustersResultsConnectionStringsPrivateEndpointList;
    get privateSrv(): string;
    get standard(): string;
    get standardSrv(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsConnectionStringsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsConnectionStringsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsLabels {
}
export declare function dataMongodbatlasAdvancedClustersResultsLabelsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsLabels): any;
export declare function dataMongodbatlasAdvancedClustersResultsLabelsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsLabels): any;
export declare class DataMongodbatlasAdvancedClustersResultsLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsLabels | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsLabels | undefined);
    get key(): string;
    get value(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsLabelsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScaling {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScaling): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScaling): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScaling | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScaling | undefined);
    get computeEnabled(): cdktf.IResolvable;
    get computeMaxInstanceSize(): string;
    get computeMinInstanceSize(): string;
    get computeScaleDownEnabled(): cdktf.IResolvable;
    get diskGbEnabled(): cdktf.IResolvable;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecs {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecs): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecs): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecs | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecs | undefined);
    get diskIops(): number;
    get diskSizeGb(): number;
    get ebsVolumeType(): string;
    get instanceSize(): string;
    get nodeCount(): number;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScaling {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScaling): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScaling): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScaling | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScaling | undefined);
    get computeEnabled(): cdktf.IResolvable;
    get computeMaxInstanceSize(): string;
    get computeMinInstanceSize(): string;
    get computeScaleDownEnabled(): cdktf.IResolvable;
    get diskGbEnabled(): cdktf.IResolvable;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecs {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecs): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecs): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecs | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecs | undefined);
    get diskIops(): number;
    get diskSizeGb(): number;
    get ebsVolumeType(): string;
    get instanceSize(): string;
    get nodeCount(): number;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecs {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecs): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecs): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecs | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecs | undefined);
    get diskIops(): number;
    get diskSizeGb(): number;
    get ebsVolumeType(): string;
    get instanceSize(): string;
    get nodeCount(): number;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigs {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigs): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigs): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigs | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigs | undefined);
    private _analyticsAutoScaling;
    get analyticsAutoScaling(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsAutoScalingList;
    private _analyticsSpecs;
    get analyticsSpecs(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAnalyticsSpecsList;
    private _autoScaling;
    get autoScaling(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsAutoScalingList;
    get backingProviderName(): string;
    private _electableSpecs;
    get electableSpecs(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsElectableSpecsList;
    get priority(): number;
    get providerName(): string;
    private _readOnlySpecs;
    get readOnlySpecs(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsReadOnlySpecsList;
    get regionName(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsReplicationSpecs {
}
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecs): any;
export declare function dataMongodbatlasAdvancedClustersResultsReplicationSpecsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsReplicationSpecs): any;
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsReplicationSpecs | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsReplicationSpecs | undefined);
    private _containerId;
    get containerId(): cdktf.StringMap;
    get externalId(): string;
    get id(): string;
    get numShards(): number;
    private _regionConfigs;
    get regionConfigs(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsRegionConfigsList;
    get zoneId(): string;
    get zoneName(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsReplicationSpecsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsReplicationSpecsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResultsTags {
}
export declare function dataMongodbatlasAdvancedClustersResultsTagsToTerraform(struct?: DataMongodbatlasAdvancedClustersResultsTags): any;
export declare function dataMongodbatlasAdvancedClustersResultsTagsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResultsTags): any;
export declare class DataMongodbatlasAdvancedClustersResultsTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResultsTags | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResultsTags | undefined);
    get key(): string;
    get value(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsTagsOutputReference;
}
export interface DataMongodbatlasAdvancedClustersResults {
}
export declare function dataMongodbatlasAdvancedClustersResultsToTerraform(struct?: DataMongodbatlasAdvancedClustersResults): any;
export declare function dataMongodbatlasAdvancedClustersResultsToHclTerraform(struct?: DataMongodbatlasAdvancedClustersResults): any;
export declare class DataMongodbatlasAdvancedClustersResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAdvancedClustersResults | undefined;
    set internalValue(value: DataMongodbatlasAdvancedClustersResults | undefined);
    private _advancedConfiguration;
    get advancedConfiguration(): DataMongodbatlasAdvancedClustersResultsAdvancedConfigurationList;
    get backupEnabled(): cdktf.IResolvable;
    private _biConnectorConfig;
    get biConnectorConfig(): DataMongodbatlasAdvancedClustersResultsBiConnectorConfigList;
    get clusterType(): string;
    private _connectionStrings;
    get connectionStrings(): DataMongodbatlasAdvancedClustersResultsConnectionStringsList;
    get createDate(): string;
    get diskSizeGb(): number;
    get encryptionAtRestProvider(): string;
    get globalClusterSelfManagedSharding(): cdktf.IResolvable;
    private _labels;
    get labels(): DataMongodbatlasAdvancedClustersResultsLabelsList;
    get mongoDbMajorVersion(): string;
    get mongoDbVersion(): string;
    get name(): string;
    get paused(): cdktf.IResolvable;
    get pitEnabled(): cdktf.IResolvable;
    get redactClientLogData(): cdktf.IResolvable;
    get replicaSetScalingStrategy(): string;
    private _replicationSpecs;
    get replicationSpecs(): DataMongodbatlasAdvancedClustersResultsReplicationSpecsList;
    get rootCertType(): string;
    get stateName(): string;
    private _tags;
    get tags(): DataMongodbatlasAdvancedClustersResultsTagsList;
    get terminationProtectionEnabled(): cdktf.IResolvable;
    get versionReleaseSystem(): string;
}
export declare class DataMongodbatlasAdvancedClustersResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAdvancedClustersResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters mongodbatlas_advanced_clusters}
*/
export declare class DataMongodbatlasAdvancedClusters extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_advanced_clusters";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasAdvancedClusters resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasAdvancedClusters to import
    * @param importFromId The id of the existing DataMongodbatlasAdvancedClusters that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasAdvancedClusters to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/advanced_clusters mongodbatlas_advanced_clusters} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasAdvancedClustersConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasAdvancedClustersConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasAdvancedClustersResultsList;
    private _useReplicationSpecPerShard?;
    get useReplicationSpecPerShard(): boolean | cdktf.IResolvable;
    set useReplicationSpecPerShard(value: boolean | cdktf.IResolvable);
    resetUseReplicationSpecPerShard(): void;
    get useReplicationSpecPerShardInput(): boolean | cdktf.IResolvable | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
