/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasAtlasUserConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_user#user_id DataMongodbatlasAtlasUser#user_id}
    */
    readonly userId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_user#username DataMongodbatlasAtlasUser#username}
    */
    readonly username?: string;
}
export interface DataMongodbatlasAtlasUserLinks {
}
export declare function dataMongodbatlasAtlasUserLinksToTerraform(struct?: DataMongodbatlasAtlasUserLinks): any;
export declare function dataMongodbatlasAtlasUserLinksToHclTerraform(struct?: DataMongodbatlasAtlasUserLinks): any;
export declare class DataMongodbatlasAtlasUserLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAtlasUserLinks | undefined;
    set internalValue(value: DataMongodbatlasAtlasUserLinks | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataMongodbatlasAtlasUserLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAtlasUserLinksOutputReference;
}
export interface DataMongodbatlasAtlasUserRoles {
}
export declare function dataMongodbatlasAtlasUserRolesToTerraform(struct?: DataMongodbatlasAtlasUserRoles): any;
export declare function dataMongodbatlasAtlasUserRolesToHclTerraform(struct?: DataMongodbatlasAtlasUserRoles): any;
export declare class DataMongodbatlasAtlasUserRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAtlasUserRoles | undefined;
    set internalValue(value: DataMongodbatlasAtlasUserRoles | undefined);
    get groupId(): string;
    get orgId(): string;
    get roleName(): string;
}
export declare class DataMongodbatlasAtlasUserRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAtlasUserRolesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_user mongodbatlas_atlas_user}
*/
export declare class DataMongodbatlasAtlasUser extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_atlas_user";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasAtlasUser resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasAtlasUser to import
    * @param importFromId The id of the existing DataMongodbatlasAtlasUser that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_user#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasAtlasUser to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_user mongodbatlas_atlas_user} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasAtlasUserConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataMongodbatlasAtlasUserConfig);
    get country(): string;
    get createdAt(): string;
    get emailAddress(): string;
    get firstName(): string;
    get id(): string;
    get lastAuth(): string;
    get lastName(): string;
    private _links;
    get links(): DataMongodbatlasAtlasUserLinksList;
    get mobileNumber(): string;
    private _roles;
    get roles(): DataMongodbatlasAtlasUserRolesList;
    get teamIds(): string[];
    private _userId?;
    get userId(): string;
    set userId(value: string);
    resetUserId(): void;
    get userIdInput(): string | undefined;
    private _username?;
    get username(): string;
    set username(value: string);
    resetUsername(): void;
    get usernameInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
