/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasAtlasUsersConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#items_per_page DataMongodbatlasAtlasUsers#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#org_id DataMongodbatlasAtlasUsers#org_id}
    */
    readonly orgId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#page_num DataMongodbatlasAtlasUsers#page_num}
    */
    readonly pageNum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#project_id DataMongodbatlasAtlasUsers#project_id}
    */
    readonly projectId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#team_id DataMongodbatlasAtlasUsers#team_id}
    */
    readonly teamId?: string;
}
export interface DataMongodbatlasAtlasUsersResultsLinks {
}
export declare function dataMongodbatlasAtlasUsersResultsLinksToTerraform(struct?: DataMongodbatlasAtlasUsersResultsLinks): any;
export declare function dataMongodbatlasAtlasUsersResultsLinksToHclTerraform(struct?: DataMongodbatlasAtlasUsersResultsLinks): any;
export declare class DataMongodbatlasAtlasUsersResultsLinksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAtlasUsersResultsLinks | undefined;
    set internalValue(value: DataMongodbatlasAtlasUsersResultsLinks | undefined);
    get href(): string;
    get rel(): string;
}
export declare class DataMongodbatlasAtlasUsersResultsLinksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAtlasUsersResultsLinksOutputReference;
}
export interface DataMongodbatlasAtlasUsersResultsRoles {
}
export declare function dataMongodbatlasAtlasUsersResultsRolesToTerraform(struct?: DataMongodbatlasAtlasUsersResultsRoles): any;
export declare function dataMongodbatlasAtlasUsersResultsRolesToHclTerraform(struct?: DataMongodbatlasAtlasUsersResultsRoles): any;
export declare class DataMongodbatlasAtlasUsersResultsRolesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAtlasUsersResultsRoles | undefined;
    set internalValue(value: DataMongodbatlasAtlasUsersResultsRoles | undefined);
    get groupId(): string;
    get orgId(): string;
    get roleName(): string;
}
export declare class DataMongodbatlasAtlasUsersResultsRolesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAtlasUsersResultsRolesOutputReference;
}
export interface DataMongodbatlasAtlasUsersResults {
}
export declare function dataMongodbatlasAtlasUsersResultsToTerraform(struct?: DataMongodbatlasAtlasUsersResults): any;
export declare function dataMongodbatlasAtlasUsersResultsToHclTerraform(struct?: DataMongodbatlasAtlasUsersResults): any;
export declare class DataMongodbatlasAtlasUsersResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasAtlasUsersResults | undefined;
    set internalValue(value: DataMongodbatlasAtlasUsersResults | undefined);
    get country(): string;
    get createdAt(): string;
    get emailAddress(): string;
    get firstName(): string;
    get id(): string;
    get lastAuth(): string;
    get lastName(): string;
    private _links;
    get links(): DataMongodbatlasAtlasUsersResultsLinksList;
    get mobileNumber(): string;
    private _roles;
    get roles(): DataMongodbatlasAtlasUsersResultsRolesList;
    get teamIds(): string[];
    get userId(): string;
    get username(): string;
}
export declare class DataMongodbatlasAtlasUsersResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasAtlasUsersResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users mongodbatlas_atlas_users}
*/
export declare class DataMongodbatlasAtlasUsers extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_atlas_users";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasAtlasUsers resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasAtlasUsers to import
    * @param importFromId The id of the existing DataMongodbatlasAtlasUsers that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasAtlasUsers to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/atlas_users mongodbatlas_atlas_users} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasAtlasUsersConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataMongodbatlasAtlasUsersConfig);
    get id(): string;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    resetOrgId(): void;
    get orgIdInput(): string | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasAtlasUsersResultsList;
    private _teamId?;
    get teamId(): string;
    set teamId(value: string);
    resetTeamId(): void;
    get teamIdInput(): string | undefined;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
