/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasBackupCompliancePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/backup_compliance_policy#id DataMongodbatlasBackupCompliancePolicy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/backup_compliance_policy#project_id DataMongodbatlasBackupCompliancePolicy#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem {
}
export declare function dataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem): any;
export declare function dataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem): any;
export declare class DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItem | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemDaily {
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemDailyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily): any;
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemDailyToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemDailyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemDaily | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemDaily | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemDailyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemDailyOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemHourly {
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemHourlyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly): any;
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemHourlyToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemHourly | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemHourly | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly {
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly): any;
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemMonthly | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly {
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly): any;
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemWeekly | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyOutputReference;
}
export interface DataMongodbatlasBackupCompliancePolicyPolicyItemYearly {
}
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemYearlyToTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemYearly): any;
export declare function dataMongodbatlasBackupCompliancePolicyPolicyItemYearlyToHclTerraform(struct?: DataMongodbatlasBackupCompliancePolicyPolicyItemYearly): any;
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemYearlyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasBackupCompliancePolicyPolicyItemYearly | undefined;
    set internalValue(value: DataMongodbatlasBackupCompliancePolicyPolicyItemYearly | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasBackupCompliancePolicyPolicyItemYearlyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasBackupCompliancePolicyPolicyItemYearlyOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/backup_compliance_policy mongodbatlas_backup_compliance_policy}
*/
export declare class DataMongodbatlasBackupCompliancePolicy extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_backup_compliance_policy";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasBackupCompliancePolicy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasBackupCompliancePolicy to import
    * @param importFromId The id of the existing DataMongodbatlasBackupCompliancePolicy that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/backup_compliance_policy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasBackupCompliancePolicy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/backup_compliance_policy mongodbatlas_backup_compliance_policy} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasBackupCompliancePolicyConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasBackupCompliancePolicyConfig);
    get authorizedEmail(): string;
    get authorizedUserFirstName(): string;
    get authorizedUserLastName(): string;
    get copyProtectionEnabled(): cdktf.IResolvable;
    get encryptionAtRestEnabled(): cdktf.IResolvable;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _onDemandPolicyItem;
    get onDemandPolicyItem(): DataMongodbatlasBackupCompliancePolicyOnDemandPolicyItemList;
    get pitEnabled(): cdktf.IResolvable;
    private _policyItemDaily;
    get policyItemDaily(): DataMongodbatlasBackupCompliancePolicyPolicyItemDailyList;
    private _policyItemHourly;
    get policyItemHourly(): DataMongodbatlasBackupCompliancePolicyPolicyItemHourlyList;
    private _policyItemMonthly;
    get policyItemMonthly(): DataMongodbatlasBackupCompliancePolicyPolicyItemMonthlyList;
    private _policyItemWeekly;
    get policyItemWeekly(): DataMongodbatlasBackupCompliancePolicyPolicyItemWeeklyList;
    private _policyItemYearly;
    get policyItemYearly(): DataMongodbatlasBackupCompliancePolicyPolicyItemYearlyList;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get restoreWindowDays(): number;
    get state(): string;
    get updatedDate(): string;
    get updatedUser(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
