/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasCloudProviderAccessSetupConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#id DataMongodbatlasCloudProviderAccessSetup#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#project_id DataMongodbatlasCloudProviderAccessSetup#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#provider_name DataMongodbatlasCloudProviderAccessSetup#provider_name}
    */
    readonly providerName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#role_id DataMongodbatlasCloudProviderAccessSetup#role_id}
    */
    readonly roleId: string;
    /**
    * azure_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#azure_config DataMongodbatlasCloudProviderAccessSetup#azure_config}
    */
    readonly azureConfig?: DataMongodbatlasCloudProviderAccessSetupAzureConfig[] | cdktf.IResolvable;
}
export interface DataMongodbatlasCloudProviderAccessSetupAwsConfig {
}
export declare function dataMongodbatlasCloudProviderAccessSetupAwsConfigToTerraform(struct?: DataMongodbatlasCloudProviderAccessSetupAwsConfig): any;
export declare function dataMongodbatlasCloudProviderAccessSetupAwsConfigToHclTerraform(struct?: DataMongodbatlasCloudProviderAccessSetupAwsConfig): any;
export declare class DataMongodbatlasCloudProviderAccessSetupAwsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasCloudProviderAccessSetupAwsConfig | undefined;
    set internalValue(value: DataMongodbatlasCloudProviderAccessSetupAwsConfig | undefined);
    get atlasAssumedRoleExternalId(): string;
    get atlasAwsAccountArn(): string;
}
export declare class DataMongodbatlasCloudProviderAccessSetupAwsConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasCloudProviderAccessSetupAwsConfigOutputReference;
}
export interface DataMongodbatlasCloudProviderAccessSetupAzureConfig {
}
export declare function dataMongodbatlasCloudProviderAccessSetupAzureConfigToTerraform(struct?: DataMongodbatlasCloudProviderAccessSetupAzureConfig | cdktf.IResolvable): any;
export declare function dataMongodbatlasCloudProviderAccessSetupAzureConfigToHclTerraform(struct?: DataMongodbatlasCloudProviderAccessSetupAzureConfig | cdktf.IResolvable): any;
export declare class DataMongodbatlasCloudProviderAccessSetupAzureConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasCloudProviderAccessSetupAzureConfig | cdktf.IResolvable | undefined;
    set internalValue(value: DataMongodbatlasCloudProviderAccessSetupAzureConfig | cdktf.IResolvable | undefined);
    get atlasAzureAppId(): string;
    get servicePrincipalId(): string;
    get tenantId(): string;
}
export declare class DataMongodbatlasCloudProviderAccessSetupAzureConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataMongodbatlasCloudProviderAccessSetupAzureConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasCloudProviderAccessSetupAzureConfigOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup mongodbatlas_cloud_provider_access_setup}
*/
export declare class DataMongodbatlasCloudProviderAccessSetup extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_cloud_provider_access_setup";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasCloudProviderAccessSetup resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasCloudProviderAccessSetup to import
    * @param importFromId The id of the existing DataMongodbatlasCloudProviderAccessSetup that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasCloudProviderAccessSetup to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/cloud_provider_access_setup mongodbatlas_cloud_provider_access_setup} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasCloudProviderAccessSetupConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasCloudProviderAccessSetupConfig);
    private _aws;
    get aws(): cdktf.StringMap;
    private _awsConfig;
    get awsConfig(): DataMongodbatlasCloudProviderAccessSetupAwsConfigList;
    get createdDate(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get lastUpdatedDate(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _providerName?;
    get providerName(): string;
    set providerName(value: string);
    get providerNameInput(): string | undefined;
    private _roleId?;
    get roleId(): string;
    set roleId(value: string);
    get roleIdInput(): string | undefined;
    private _azureConfig;
    get azureConfig(): DataMongodbatlasCloudProviderAccessSetupAzureConfigList;
    putAzureConfig(value: DataMongodbatlasCloudProviderAccessSetupAzureConfig[] | cdktf.IResolvable): void;
    resetAzureConfig(): void;
    get azureConfigInput(): cdktf.IResolvable | DataMongodbatlasCloudProviderAccessSetupAzureConfig[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
