/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasControlPlaneIpAddressesConfig extends cdktf.TerraformMetaArguments {
}
export interface DataMongodbatlasControlPlaneIpAddressesInbound {
}
export declare function dataMongodbatlasControlPlaneIpAddressesInboundToTerraform(struct?: DataMongodbatlasControlPlaneIpAddressesInbound): any;
export declare function dataMongodbatlasControlPlaneIpAddressesInboundToHclTerraform(struct?: DataMongodbatlasControlPlaneIpAddressesInbound): any;
export declare class DataMongodbatlasControlPlaneIpAddressesInboundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasControlPlaneIpAddressesInbound | undefined;
    set internalValue(value: DataMongodbatlasControlPlaneIpAddressesInbound | undefined);
    private _aws;
    get aws(): cdktf.StringListMap;
    private _azure;
    get azure(): cdktf.StringListMap;
    private _gcp;
    get gcp(): cdktf.StringListMap;
}
export interface DataMongodbatlasControlPlaneIpAddressesOutbound {
}
export declare function dataMongodbatlasControlPlaneIpAddressesOutboundToTerraform(struct?: DataMongodbatlasControlPlaneIpAddressesOutbound): any;
export declare function dataMongodbatlasControlPlaneIpAddressesOutboundToHclTerraform(struct?: DataMongodbatlasControlPlaneIpAddressesOutbound): any;
export declare class DataMongodbatlasControlPlaneIpAddressesOutboundOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasControlPlaneIpAddressesOutbound | undefined;
    set internalValue(value: DataMongodbatlasControlPlaneIpAddressesOutbound | undefined);
    private _aws;
    get aws(): cdktf.StringListMap;
    private _azure;
    get azure(): cdktf.StringListMap;
    private _gcp;
    get gcp(): cdktf.StringListMap;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/control_plane_ip_addresses mongodbatlas_control_plane_ip_addresses}
*/
export declare class DataMongodbatlasControlPlaneIpAddresses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_control_plane_ip_addresses";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasControlPlaneIpAddresses resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasControlPlaneIpAddresses to import
    * @param importFromId The id of the existing DataMongodbatlasControlPlaneIpAddresses that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/control_plane_ip_addresses#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasControlPlaneIpAddresses to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/control_plane_ip_addresses mongodbatlas_control_plane_ip_addresses} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasControlPlaneIpAddressesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataMongodbatlasControlPlaneIpAddressesConfig);
    private _inbound;
    get inbound(): DataMongodbatlasControlPlaneIpAddressesInboundOutputReference;
    private _outbound;
    get outbound(): DataMongodbatlasControlPlaneIpAddressesOutboundOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
