/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasDataLakePipelineRunConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run#pipeline_name DataMongodbatlasDataLakePipelineRun#pipeline_name}
    */
    readonly pipelineName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run#pipeline_run_id DataMongodbatlasDataLakePipelineRun#pipeline_run_id}
    */
    readonly pipelineRunId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run#project_id DataMongodbatlasDataLakePipelineRun#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasDataLakePipelineRunStats {
}
export declare function dataMongodbatlasDataLakePipelineRunStatsToTerraform(struct?: DataMongodbatlasDataLakePipelineRunStats): any;
export declare function dataMongodbatlasDataLakePipelineRunStatsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineRunStats): any;
export declare class DataMongodbatlasDataLakePipelineRunStatsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineRunStats | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineRunStats | undefined);
    get bytesExported(): number;
    get numDocs(): number;
}
export declare class DataMongodbatlasDataLakePipelineRunStatsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineRunStatsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run mongodbatlas_data_lake_pipeline_run}
*/
export declare class DataMongodbatlasDataLakePipelineRun extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_data_lake_pipeline_run";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasDataLakePipelineRun resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasDataLakePipelineRun to import
    * @param importFromId The id of the existing DataMongodbatlasDataLakePipelineRun that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasDataLakePipelineRun to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_run mongodbatlas_data_lake_pipeline_run} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasDataLakePipelineRunConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasDataLakePipelineRunConfig);
    get backupFrequencyType(): string;
    get createdDate(): string;
    get datasetName(): string;
    get id(): string;
    get lastUpdatedDate(): string;
    get phase(): string;
    get pipelineId(): string;
    private _pipelineName?;
    get pipelineName(): string;
    set pipelineName(value: string);
    get pipelineNameInput(): string | undefined;
    private _pipelineRunId?;
    get pipelineRunId(): string;
    set pipelineRunId(value: string);
    get pipelineRunIdInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get snapshotId(): string;
    get state(): string;
    private _stats;
    get stats(): DataMongodbatlasDataLakePipelineRunStatsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
