/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasDataLakePipelineRunsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs#id DataMongodbatlasDataLakePipelineRuns#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs#pipeline_name DataMongodbatlasDataLakePipelineRuns#pipeline_name}
    */
    readonly pipelineName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs#project_id DataMongodbatlasDataLakePipelineRuns#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasDataLakePipelineRunsResultsStats {
}
export declare function dataMongodbatlasDataLakePipelineRunsResultsStatsToTerraform(struct?: DataMongodbatlasDataLakePipelineRunsResultsStats): any;
export declare function dataMongodbatlasDataLakePipelineRunsResultsStatsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineRunsResultsStats): any;
export declare class DataMongodbatlasDataLakePipelineRunsResultsStatsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineRunsResultsStats | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineRunsResultsStats | undefined);
    get bytesExported(): number;
    get numDocs(): number;
}
export declare class DataMongodbatlasDataLakePipelineRunsResultsStatsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineRunsResultsStatsOutputReference;
}
export interface DataMongodbatlasDataLakePipelineRunsResults {
}
export declare function dataMongodbatlasDataLakePipelineRunsResultsToTerraform(struct?: DataMongodbatlasDataLakePipelineRunsResults): any;
export declare function dataMongodbatlasDataLakePipelineRunsResultsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineRunsResults): any;
export declare class DataMongodbatlasDataLakePipelineRunsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineRunsResults | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineRunsResults | undefined);
    get backupFrequencyType(): string;
    get createdDate(): string;
    get id(): string;
    get lastUpdatedDate(): string;
    get phase(): string;
    get pipelineId(): string;
    get pipelineRunId(): string;
    get snapshotId(): string;
    get state(): string;
    private _stats;
    get stats(): DataMongodbatlasDataLakePipelineRunsResultsStatsList;
}
export declare class DataMongodbatlasDataLakePipelineRunsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineRunsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs mongodbatlas_data_lake_pipeline_runs}
*/
export declare class DataMongodbatlasDataLakePipelineRuns extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_data_lake_pipeline_runs";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasDataLakePipelineRuns resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasDataLakePipelineRuns to import
    * @param importFromId The id of the existing DataMongodbatlasDataLakePipelineRuns that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasDataLakePipelineRuns to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline_runs mongodbatlas_data_lake_pipeline_runs} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasDataLakePipelineRunsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasDataLakePipelineRunsConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _pipelineName?;
    get pipelineName(): string;
    set pipelineName(value: string);
    get pipelineNameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasDataLakePipelineRunsResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
