/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasDataLakePipelineConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline#name DataMongodbatlasDataLakePipeline#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline#project_id DataMongodbatlasDataLakePipeline#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasDataLakePipelineIngestionSchedules {
}
export declare function dataMongodbatlasDataLakePipelineIngestionSchedulesToTerraform(struct?: DataMongodbatlasDataLakePipelineIngestionSchedules): any;
export declare function dataMongodbatlasDataLakePipelineIngestionSchedulesToHclTerraform(struct?: DataMongodbatlasDataLakePipelineIngestionSchedules): any;
export declare class DataMongodbatlasDataLakePipelineIngestionSchedulesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineIngestionSchedules | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineIngestionSchedules | undefined);
    get frequencyInterval(): number;
    get frequencyType(): string;
    get id(): string;
    get retentionUnit(): string;
    get retentionValue(): number;
}
export declare class DataMongodbatlasDataLakePipelineIngestionSchedulesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineIngestionSchedulesOutputReference;
}
export interface DataMongodbatlasDataLakePipelineSinkPartitionFields {
}
export declare function dataMongodbatlasDataLakePipelineSinkPartitionFieldsToTerraform(struct?: DataMongodbatlasDataLakePipelineSinkPartitionFields): any;
export declare function dataMongodbatlasDataLakePipelineSinkPartitionFieldsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineSinkPartitionFields): any;
export declare class DataMongodbatlasDataLakePipelineSinkPartitionFieldsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineSinkPartitionFields | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineSinkPartitionFields | undefined);
    get fieldName(): string;
    get order(): number;
}
export declare class DataMongodbatlasDataLakePipelineSinkPartitionFieldsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineSinkPartitionFieldsOutputReference;
}
export interface DataMongodbatlasDataLakePipelineSink {
}
export declare function dataMongodbatlasDataLakePipelineSinkToTerraform(struct?: DataMongodbatlasDataLakePipelineSink): any;
export declare function dataMongodbatlasDataLakePipelineSinkToHclTerraform(struct?: DataMongodbatlasDataLakePipelineSink): any;
export declare class DataMongodbatlasDataLakePipelineSinkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineSink | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineSink | undefined);
    private _partitionFields;
    get partitionFields(): DataMongodbatlasDataLakePipelineSinkPartitionFieldsList;
    get provider(): string;
    get region(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelineSinkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineSinkOutputReference;
}
export interface DataMongodbatlasDataLakePipelineSnapshots {
}
export declare function dataMongodbatlasDataLakePipelineSnapshotsToTerraform(struct?: DataMongodbatlasDataLakePipelineSnapshots): any;
export declare function dataMongodbatlasDataLakePipelineSnapshotsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineSnapshots): any;
export declare class DataMongodbatlasDataLakePipelineSnapshotsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineSnapshots | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineSnapshots | undefined);
    get copyRegion(): string;
    get createdAt(): string;
    get expiresAt(): string;
    get frequencyYype(): string;
    get id(): string;
    get masterKey(): string;
    get mongodVersion(): string;
    get policies(): string[];
    get provider(): string;
    get replicaSetName(): string;
    get size(): number;
    get status(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelineSnapshotsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineSnapshotsOutputReference;
}
export interface DataMongodbatlasDataLakePipelineSource {
}
export declare function dataMongodbatlasDataLakePipelineSourceToTerraform(struct?: DataMongodbatlasDataLakePipelineSource): any;
export declare function dataMongodbatlasDataLakePipelineSourceToHclTerraform(struct?: DataMongodbatlasDataLakePipelineSource): any;
export declare class DataMongodbatlasDataLakePipelineSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineSource | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineSource | undefined);
    get clusterName(): string;
    get collectionName(): string;
    get databaseName(): string;
    get projectId(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelineSourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineSourceOutputReference;
}
export interface DataMongodbatlasDataLakePipelineTransformations {
}
export declare function dataMongodbatlasDataLakePipelineTransformationsToTerraform(struct?: DataMongodbatlasDataLakePipelineTransformations): any;
export declare function dataMongodbatlasDataLakePipelineTransformationsToHclTerraform(struct?: DataMongodbatlasDataLakePipelineTransformations): any;
export declare class DataMongodbatlasDataLakePipelineTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelineTransformations | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelineTransformations | undefined);
    get field(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelineTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelineTransformationsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline mongodbatlas_data_lake_pipeline}
*/
export declare class DataMongodbatlasDataLakePipeline extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_data_lake_pipeline";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasDataLakePipeline resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasDataLakePipeline to import
    * @param importFromId The id of the existing DataMongodbatlasDataLakePipeline that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasDataLakePipeline to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipeline mongodbatlas_data_lake_pipeline} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasDataLakePipelineConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasDataLakePipelineConfig);
    get createdDate(): string;
    get id(): string;
    private _ingestionSchedules;
    get ingestionSchedules(): DataMongodbatlasDataLakePipelineIngestionSchedulesList;
    get lastUpdatedDate(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _sink;
    get sink(): DataMongodbatlasDataLakePipelineSinkList;
    private _snapshots;
    get snapshots(): DataMongodbatlasDataLakePipelineSnapshotsList;
    private _source;
    get source(): DataMongodbatlasDataLakePipelineSourceList;
    get state(): string;
    private _transformations;
    get transformations(): DataMongodbatlasDataLakePipelineTransformationsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
