/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasDataLakePipelinesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipelines#id DataMongodbatlasDataLakePipelines#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipelines#project_id DataMongodbatlasDataLakePipelines#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasDataLakePipelinesResultsSinkPartitionFields {
}
export declare function dataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsToTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSinkPartitionFields): any;
export declare function dataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsToHclTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSinkPartitionFields): any;
export declare class DataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelinesResultsSinkPartitionFields | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelinesResultsSinkPartitionFields | undefined);
    get fieldName(): string;
    get order(): number;
}
export declare class DataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsOutputReference;
}
export interface DataMongodbatlasDataLakePipelinesResultsSink {
}
export declare function dataMongodbatlasDataLakePipelinesResultsSinkToTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSink): any;
export declare function dataMongodbatlasDataLakePipelinesResultsSinkToHclTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSink): any;
export declare class DataMongodbatlasDataLakePipelinesResultsSinkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelinesResultsSink | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelinesResultsSink | undefined);
    private _partitionFields;
    get partitionFields(): DataMongodbatlasDataLakePipelinesResultsSinkPartitionFieldsList;
    get provider(): string;
    get region(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelinesResultsSinkList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelinesResultsSinkOutputReference;
}
export interface DataMongodbatlasDataLakePipelinesResultsSource {
}
export declare function dataMongodbatlasDataLakePipelinesResultsSourceToTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSource): any;
export declare function dataMongodbatlasDataLakePipelinesResultsSourceToHclTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsSource): any;
export declare class DataMongodbatlasDataLakePipelinesResultsSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelinesResultsSource | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelinesResultsSource | undefined);
    get clusterName(): string;
    get collectionName(): string;
    get databaseName(): string;
    get projectId(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelinesResultsSourceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelinesResultsSourceOutputReference;
}
export interface DataMongodbatlasDataLakePipelinesResultsTransformations {
}
export declare function dataMongodbatlasDataLakePipelinesResultsTransformationsToTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsTransformations): any;
export declare function dataMongodbatlasDataLakePipelinesResultsTransformationsToHclTerraform(struct?: DataMongodbatlasDataLakePipelinesResultsTransformations): any;
export declare class DataMongodbatlasDataLakePipelinesResultsTransformationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelinesResultsTransformations | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelinesResultsTransformations | undefined);
    get field(): string;
    get type(): string;
}
export declare class DataMongodbatlasDataLakePipelinesResultsTransformationsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelinesResultsTransformationsOutputReference;
}
export interface DataMongodbatlasDataLakePipelinesResults {
}
export declare function dataMongodbatlasDataLakePipelinesResultsToTerraform(struct?: DataMongodbatlasDataLakePipelinesResults): any;
export declare function dataMongodbatlasDataLakePipelinesResultsToHclTerraform(struct?: DataMongodbatlasDataLakePipelinesResults): any;
export declare class DataMongodbatlasDataLakePipelinesResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasDataLakePipelinesResults | undefined;
    set internalValue(value: DataMongodbatlasDataLakePipelinesResults | undefined);
    get createdDate(): string;
    get id(): string;
    get lastUpdatedDate(): string;
    get name(): string;
    get projectId(): string;
    private _sink;
    get sink(): DataMongodbatlasDataLakePipelinesResultsSinkList;
    private _source;
    get source(): DataMongodbatlasDataLakePipelinesResultsSourceList;
    get state(): string;
    private _transformations;
    get transformations(): DataMongodbatlasDataLakePipelinesResultsTransformationsList;
}
export declare class DataMongodbatlasDataLakePipelinesResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasDataLakePipelinesResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipelines mongodbatlas_data_lake_pipelines}
*/
export declare class DataMongodbatlasDataLakePipelines extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_data_lake_pipelines";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasDataLakePipelines resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasDataLakePipelines to import
    * @param importFromId The id of the existing DataMongodbatlasDataLakePipelines that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipelines#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasDataLakePipelines to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/data_lake_pipelines mongodbatlas_data_lake_pipelines} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasDataLakePipelinesConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasDataLakePipelinesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasDataLakePipelinesResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
