/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasEncryptionAtRestPrivateEndpointsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Label that identifies the cloud provider of the private endpoint.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest_private_endpoints#cloud_provider DataMongodbatlasEncryptionAtRestPrivateEndpoints#cloud_provider}
    */
    readonly cloudProvider: string;
    /**
    * Unique 24-hexadecimal digit string that identifies your project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest_private_endpoints#project_id DataMongodbatlasEncryptionAtRestPrivateEndpoints#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasEncryptionAtRestPrivateEndpointsResults {
}
export declare function dataMongodbatlasEncryptionAtRestPrivateEndpointsResultsToTerraform(struct?: DataMongodbatlasEncryptionAtRestPrivateEndpointsResults): any;
export declare function dataMongodbatlasEncryptionAtRestPrivateEndpointsResultsToHclTerraform(struct?: DataMongodbatlasEncryptionAtRestPrivateEndpointsResults): any;
export declare class DataMongodbatlasEncryptionAtRestPrivateEndpointsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEncryptionAtRestPrivateEndpointsResults | undefined;
    set internalValue(value: DataMongodbatlasEncryptionAtRestPrivateEndpointsResults | undefined);
    get cloudProvider(): string;
    get errorMessage(): string;
    get id(): string;
    get privateEndpointConnectionName(): string;
    get projectId(): string;
    get regionName(): string;
    get status(): string;
}
export declare class DataMongodbatlasEncryptionAtRestPrivateEndpointsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEncryptionAtRestPrivateEndpointsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest_private_endpoints mongodbatlas_encryption_at_rest_private_endpoints}
*/
export declare class DataMongodbatlasEncryptionAtRestPrivateEndpoints extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_encryption_at_rest_private_endpoints";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasEncryptionAtRestPrivateEndpoints resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasEncryptionAtRestPrivateEndpoints to import
    * @param importFromId The id of the existing DataMongodbatlasEncryptionAtRestPrivateEndpoints that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest_private_endpoints#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasEncryptionAtRestPrivateEndpoints to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest_private_endpoints mongodbatlas_encryption_at_rest_private_endpoints} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasEncryptionAtRestPrivateEndpointsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasEncryptionAtRestPrivateEndpointsConfig);
    private _cloudProvider?;
    get cloudProvider(): string;
    set cloudProvider(value: string);
    get cloudProviderInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasEncryptionAtRestPrivateEndpointsResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
