/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasEncryptionAtRestConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique 24-hexadecimal digit string that identifies your project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest#project_id DataMongodbatlasEncryptionAtRest#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasEncryptionAtRestAwsKmsConfig {
}
export declare function dataMongodbatlasEncryptionAtRestAwsKmsConfigToTerraform(struct?: DataMongodbatlasEncryptionAtRestAwsKmsConfig): any;
export declare function dataMongodbatlasEncryptionAtRestAwsKmsConfigToHclTerraform(struct?: DataMongodbatlasEncryptionAtRestAwsKmsConfig): any;
export declare class DataMongodbatlasEncryptionAtRestAwsKmsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasEncryptionAtRestAwsKmsConfig | undefined;
    set internalValue(value: DataMongodbatlasEncryptionAtRestAwsKmsConfig | undefined);
    get accessKeyId(): string;
    get customerMasterKeyId(): string;
    get enabled(): cdktf.IResolvable;
    get region(): string;
    get roleId(): string;
    get secretAccessKey(): string;
    get valid(): cdktf.IResolvable;
}
export interface DataMongodbatlasEncryptionAtRestAzureKeyVaultConfig {
}
export declare function dataMongodbatlasEncryptionAtRestAzureKeyVaultConfigToTerraform(struct?: DataMongodbatlasEncryptionAtRestAzureKeyVaultConfig): any;
export declare function dataMongodbatlasEncryptionAtRestAzureKeyVaultConfigToHclTerraform(struct?: DataMongodbatlasEncryptionAtRestAzureKeyVaultConfig): any;
export declare class DataMongodbatlasEncryptionAtRestAzureKeyVaultConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasEncryptionAtRestAzureKeyVaultConfig | undefined;
    set internalValue(value: DataMongodbatlasEncryptionAtRestAzureKeyVaultConfig | undefined);
    get azureEnvironment(): string;
    get clientId(): string;
    get enabled(): cdktf.IResolvable;
    get keyIdentifier(): string;
    get keyVaultName(): string;
    get requirePrivateNetworking(): cdktf.IResolvable;
    get resourceGroupName(): string;
    get secret(): string;
    get subscriptionId(): string;
    get tenantId(): string;
    get valid(): cdktf.IResolvable;
}
export interface DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfig {
}
export declare function dataMongodbatlasEncryptionAtRestGoogleCloudKmsConfigToTerraform(struct?: DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfig): any;
export declare function dataMongodbatlasEncryptionAtRestGoogleCloudKmsConfigToHclTerraform(struct?: DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfig): any;
export declare class DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfig | undefined;
    set internalValue(value: DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfig | undefined);
    get enabled(): cdktf.IResolvable;
    get keyVersionResourceId(): string;
    get serviceAccountKey(): string;
    get valid(): cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest mongodbatlas_encryption_at_rest}
*/
export declare class DataMongodbatlasEncryptionAtRest extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_encryption_at_rest";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasEncryptionAtRest resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasEncryptionAtRest to import
    * @param importFromId The id of the existing DataMongodbatlasEncryptionAtRest that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasEncryptionAtRest to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/encryption_at_rest mongodbatlas_encryption_at_rest} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasEncryptionAtRestConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasEncryptionAtRestConfig);
    private _awsKmsConfig;
    get awsKmsConfig(): DataMongodbatlasEncryptionAtRestAwsKmsConfigOutputReference;
    private _azureKeyVaultConfig;
    get azureKeyVaultConfig(): DataMongodbatlasEncryptionAtRestAzureKeyVaultConfigOutputReference;
    private _googleCloudKmsConfig;
    get googleCloudKmsConfig(): DataMongodbatlasEncryptionAtRestGoogleCloudKmsConfigOutputReference;
    get id(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
