/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasEventTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger#app_id DataMongodbatlasEventTrigger#app_id}
    */
    readonly appId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger#id DataMongodbatlasEventTrigger#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger#project_id DataMongodbatlasEventTrigger#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger#trigger_id DataMongodbatlasEventTrigger#trigger_id}
    */
    readonly triggerId: string;
}
export interface DataMongodbatlasEventTriggerEventProcessorsAwsEventbridge {
}
export declare function dataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeToTerraform(struct?: DataMongodbatlasEventTriggerEventProcessorsAwsEventbridge): any;
export declare function dataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeToHclTerraform(struct?: DataMongodbatlasEventTriggerEventProcessorsAwsEventbridge): any;
export declare class DataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEventTriggerEventProcessorsAwsEventbridge | undefined;
    set internalValue(value: DataMongodbatlasEventTriggerEventProcessorsAwsEventbridge | undefined);
    get configAccountId(): string;
    get configRegion(): string;
}
export declare class DataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeOutputReference;
}
export interface DataMongodbatlasEventTriggerEventProcessors {
}
export declare function dataMongodbatlasEventTriggerEventProcessorsToTerraform(struct?: DataMongodbatlasEventTriggerEventProcessors): any;
export declare function dataMongodbatlasEventTriggerEventProcessorsToHclTerraform(struct?: DataMongodbatlasEventTriggerEventProcessors): any;
export declare class DataMongodbatlasEventTriggerEventProcessorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEventTriggerEventProcessors | undefined;
    set internalValue(value: DataMongodbatlasEventTriggerEventProcessors | undefined);
    private _awsEventbridge;
    get awsEventbridge(): DataMongodbatlasEventTriggerEventProcessorsAwsEventbridgeList;
}
export declare class DataMongodbatlasEventTriggerEventProcessorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEventTriggerEventProcessorsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger mongodbatlas_event_trigger}
*/
export declare class DataMongodbatlasEventTrigger extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_event_trigger";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasEventTrigger resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasEventTrigger to import
    * @param importFromId The id of the existing DataMongodbatlasEventTrigger that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasEventTrigger to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_trigger mongodbatlas_event_trigger} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasEventTriggerConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasEventTriggerConfig);
    private _appId?;
    get appId(): string;
    set appId(value: string);
    get appIdInput(): string | undefined;
    get configCollection(): string;
    get configDatabase(): string;
    get configFullDocument(): cdktf.IResolvable;
    get configFullDocumentBefore(): cdktf.IResolvable;
    get configMatch(): string;
    get configOperationType(): string;
    get configOperationTypes(): string[];
    get configProject(): string;
    get configProviders(): string[];
    get configSchedule(): string;
    get configScheduleType(): string;
    get configServiceId(): string;
    get disabled(): cdktf.IResolvable;
    private _eventProcessors;
    get eventProcessors(): DataMongodbatlasEventTriggerEventProcessorsList;
    get functionId(): string;
    get functionName(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get name(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _triggerId?;
    get triggerId(): string;
    set triggerId(value: string);
    get triggerIdInput(): string | undefined;
    get type(): string;
    get unordered(): cdktf.IResolvable;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
