/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasEventTriggersConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers#app_id DataMongodbatlasEventTriggers#app_id}
    */
    readonly appId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers#id DataMongodbatlasEventTriggers#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers#project_id DataMongodbatlasEventTriggers#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridge {
}
export declare function dataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeToTerraform(struct?: DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridge): any;
export declare function dataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeToHclTerraform(struct?: DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridge): any;
export declare class DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridge | undefined;
    set internalValue(value: DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridge | undefined);
    get configAccountId(): string;
    get configRegion(): string;
}
export declare class DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeOutputReference;
}
export interface DataMongodbatlasEventTriggersResultsEventProcessors {
}
export declare function dataMongodbatlasEventTriggersResultsEventProcessorsToTerraform(struct?: DataMongodbatlasEventTriggersResultsEventProcessors): any;
export declare function dataMongodbatlasEventTriggersResultsEventProcessorsToHclTerraform(struct?: DataMongodbatlasEventTriggersResultsEventProcessors): any;
export declare class DataMongodbatlasEventTriggersResultsEventProcessorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEventTriggersResultsEventProcessors | undefined;
    set internalValue(value: DataMongodbatlasEventTriggersResultsEventProcessors | undefined);
    private _awsEventbridge;
    get awsEventbridge(): DataMongodbatlasEventTriggersResultsEventProcessorsAwsEventbridgeList;
}
export declare class DataMongodbatlasEventTriggersResultsEventProcessorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEventTriggersResultsEventProcessorsOutputReference;
}
export interface DataMongodbatlasEventTriggersResults {
}
export declare function dataMongodbatlasEventTriggersResultsToTerraform(struct?: DataMongodbatlasEventTriggersResults): any;
export declare function dataMongodbatlasEventTriggersResultsToHclTerraform(struct?: DataMongodbatlasEventTriggersResults): any;
export declare class DataMongodbatlasEventTriggersResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasEventTriggersResults | undefined;
    set internalValue(value: DataMongodbatlasEventTriggersResults | undefined);
    get configCollection(): string;
    get configDatabase(): string;
    get configFullDocument(): cdktf.IResolvable;
    get configFullDocumentBefore(): cdktf.IResolvable;
    get configMatch(): string;
    get configOperationType(): string;
    get configOperationTypes(): string[];
    get configProject(): string;
    get configProviders(): string[];
    get configSchedule(): string;
    get configScheduleType(): string;
    get configServiceId(): string;
    get disabled(): cdktf.IResolvable;
    private _eventProcessors;
    get eventProcessors(): DataMongodbatlasEventTriggersResultsEventProcessorsList;
    get functionId(): string;
    get functionName(): string;
    get name(): string;
    get triggerId(): string;
    get type(): string;
    get unordered(): cdktf.IResolvable;
}
export declare class DataMongodbatlasEventTriggersResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasEventTriggersResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers mongodbatlas_event_triggers}
*/
export declare class DataMongodbatlasEventTriggers extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_event_triggers";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasEventTriggers resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasEventTriggers to import
    * @param importFromId The id of the existing DataMongodbatlasEventTriggers that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasEventTriggers to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/event_triggers mongodbatlas_event_triggers} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasEventTriggersConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasEventTriggersConfig);
    private _appId?;
    get appId(): string;
    set appId(value: string);
    get appIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasEventTriggersResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
