/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedDatabaseInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#id DataMongodbatlasFederatedDatabaseInstance#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#name DataMongodbatlasFederatedDatabaseInstance#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#project_id DataMongodbatlasFederatedDatabaseInstance#project_id}
    */
    readonly projectId: string;
    /**
    * cloud_provider_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#cloud_provider_config DataMongodbatlasFederatedDatabaseInstance#cloud_provider_config}
    */
    readonly cloudProviderConfig?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig;
}
export interface DataMongodbatlasFederatedDatabaseInstanceDataProcessRegion {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceDataProcessRegionToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceDataProcessRegion): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceDataProcessRegionToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceDataProcessRegion): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceDataProcessRegion | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceDataProcessRegion | undefined);
    get cloudProvider(): string;
    get region(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceDataProcessRegionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceDataProcessRegionOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSources {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSources): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSources): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSources | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSources | undefined);
    get allowInsecure(): cdktf.IResolvable;
    get collection(): string;
    get collectionRegex(): string;
    get database(): string;
    get databaseRegex(): string;
    get datasetName(): string;
    get defaultFormat(): string;
    get path(): string;
    get provenanceFieldName(): string;
    get storeName(): string;
    get urls(): string[];
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollections {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollections): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollections): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollections | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollections | undefined);
    private _dataSources;
    get dataSources(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsDataSourcesList;
    get name(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViews {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViews): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViews): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViews | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViews | undefined);
    get name(): string;
    get pipeline(): string;
    get source(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageDatabases {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabases): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageDatabasesToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageDatabases): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabases | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageDatabases | undefined);
    private _collections;
    get collections(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesCollectionsList;
    get maxWildcardCollections(): number;
    get name(): string;
    private _views;
    get views(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesViewsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTags {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTags): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTags): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTags | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTags | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSets {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSets): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSets): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSets | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSets | undefined);
    private _tags;
    get tags(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsTagsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreference {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreference): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreference): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreference | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreference | undefined);
    get maxStalenessSeconds(): number;
    get mode(): string;
    private _tagSets;
    get tagSets(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceTagSetsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceStorageStores {
}
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStores): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceStorageStoresToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceStorageStores): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceStorageStores | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceStorageStores | undefined);
    get additionalStorageClasses(): string[];
    get allowInsecure(): cdktf.IResolvable;
    get bucket(): string;
    get clusterName(): string;
    get defaultFormat(): string;
    get delimiter(): string;
    get includeTags(): cdktf.IResolvable;
    get name(): string;
    get prefix(): string;
    get projectId(): string;
    get provider(): string;
    get public(): string;
    private _readPreference;
    get readPreference(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresReadPreferenceList;
    get region(): string;
    get urls(): string[];
}
export declare class DataMongodbatlasFederatedDatabaseInstanceStorageStoresList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstanceStorageStoresOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#test_s3_bucket DataMongodbatlasFederatedDatabaseInstance#test_s3_bucket}
    */
    readonly testS3Bucket?: string;
}
export declare function dataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsOutputReference | DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsOutputReference | DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws | undefined);
    get externalId(): string;
    get iamAssumedRoleArn(): string;
    get iamUserArn(): string;
    get roleId(): string;
    private _testS3Bucket?;
    get testS3Bucket(): string;
    set testS3Bucket(value: string);
    resetTestS3Bucket(): void;
    get testS3BucketInput(): string | undefined;
}
export interface DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig {
    /**
    * aws block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#aws DataMongodbatlasFederatedDatabaseInstance#aws}
    */
    readonly aws?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws;
}
export declare function dataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigOutputReference | DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig): any;
export declare function dataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigOutputReference | DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig): any;
export declare class DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig | undefined);
    private _aws;
    get aws(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAwsOutputReference;
    putAws(value: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws): void;
    resetAws(): void;
    get awsInput(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigAws | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance mongodbatlas_federated_database_instance}
*/
export declare class DataMongodbatlasFederatedDatabaseInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_database_instance";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedDatabaseInstance resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedDatabaseInstance to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedDatabaseInstance that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedDatabaseInstance to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instance mongodbatlas_federated_database_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedDatabaseInstanceConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedDatabaseInstanceConfig);
    private _dataProcessRegion;
    get dataProcessRegion(): DataMongodbatlasFederatedDatabaseInstanceDataProcessRegionList;
    get hostnames(): string[];
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get state(): string;
    private _storageDatabases;
    get storageDatabases(): DataMongodbatlasFederatedDatabaseInstanceStorageDatabasesList;
    private _storageStores;
    get storageStores(): DataMongodbatlasFederatedDatabaseInstanceStorageStoresList;
    private _cloudProviderConfig;
    get cloudProviderConfig(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfigOutputReference;
    putCloudProviderConfig(value: DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig): void;
    resetCloudProviderConfig(): void;
    get cloudProviderConfigInput(): DataMongodbatlasFederatedDatabaseInstanceCloudProviderConfig | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
