/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedDatabaseInstancesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instances#id DataMongodbatlasFederatedDatabaseInstances#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instances#project_id DataMongodbatlasFederatedDatabaseInstances#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAws {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAws): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAws): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAws | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAws | undefined);
    get externalId(): string;
    get iamAssumedRoleArn(): string;
    get iamUserArn(): string;
    get roleId(): string;
    get testS3Bucket(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfig {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfig): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfig): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfig | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfig | undefined);
    private _aws;
    get aws(): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigAwsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegion {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegion): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegion): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegion | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegion | undefined);
    get cloudProvider(): string;
    get region(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSources {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSources): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSources): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSources | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSources | undefined);
    get allowInsecure(): cdktf.IResolvable;
    get collection(): string;
    get collectionRegex(): string;
    get database(): string;
    get databaseRegex(): string;
    get datasetName(): string;
    get defaultFormat(): string;
    get path(): string;
    get provenanceFieldName(): string;
    get storeName(): string;
    get urls(): string[];
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollections {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollections): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollections): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollections | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollections | undefined);
    private _dataSources;
    get dataSources(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsDataSourcesList;
    get name(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViews {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViews): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViews): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViews | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViews | undefined);
    get name(): string;
    get pipeline(): string;
    get source(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabases {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabases): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabases): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabases | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabases | undefined);
    private _collections;
    get collections(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesCollectionsList;
    get maxWildcardCollections(): number;
    get name(): string;
    private _views;
    get views(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesViewsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTags {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTags): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTags): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTags | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTags | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSets {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSets): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSets): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSets | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSets | undefined);
    private _tags;
    get tags(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsTagsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreference {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreference): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreference): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreference | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreference | undefined);
    get maxStalenessSeconds(): number;
    get mode(): string;
    private _tagSets;
    get tagSets(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceTagSetsList;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResultsStorageStores {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStores): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStores): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStores | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResultsStorageStores | undefined);
    get additionalStorageClasses(): string[];
    get allowInsecure(): cdktf.IResolvable;
    get bucket(): string;
    get clusterName(): string;
    get defaultFormat(): string;
    get delimiter(): string;
    get includeTags(): cdktf.IResolvable;
    get name(): string;
    get prefix(): string;
    get projectId(): string;
    get provider(): string;
    get public(): string;
    private _readPreference;
    get readPreference(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresReadPreferenceList;
    get region(): string;
    get urls(): string[];
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresOutputReference;
}
export interface DataMongodbatlasFederatedDatabaseInstancesResults {
}
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsToTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResults): any;
export declare function dataMongodbatlasFederatedDatabaseInstancesResultsToHclTerraform(struct?: DataMongodbatlasFederatedDatabaseInstancesResults): any;
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedDatabaseInstancesResults | undefined;
    set internalValue(value: DataMongodbatlasFederatedDatabaseInstancesResults | undefined);
    private _cloudProviderConfig;
    get cloudProviderConfig(): DataMongodbatlasFederatedDatabaseInstancesResultsCloudProviderConfigList;
    private _dataProcessRegion;
    get dataProcessRegion(): DataMongodbatlasFederatedDatabaseInstancesResultsDataProcessRegionList;
    get hostnames(): string[];
    get name(): string;
    get projectId(): string;
    get state(): string;
    private _storageDatabases;
    get storageDatabases(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageDatabasesList;
    private _storageStores;
    get storageStores(): DataMongodbatlasFederatedDatabaseInstancesResultsStorageStoresList;
}
export declare class DataMongodbatlasFederatedDatabaseInstancesResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedDatabaseInstancesResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instances mongodbatlas_federated_database_instances}
*/
export declare class DataMongodbatlasFederatedDatabaseInstances extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_database_instances";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedDatabaseInstances resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedDatabaseInstances to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedDatabaseInstances that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instances#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedDatabaseInstances to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_database_instances mongodbatlas_federated_database_instances} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedDatabaseInstancesConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedDatabaseInstancesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasFederatedDatabaseInstancesResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
