/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedSettingsIdentityProvidersConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers#federation_settings_id DataMongodbatlasFederatedSettingsIdentityProviders#federation_settings_id}
    */
    readonly federationSettingsId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers#id DataMongodbatlasFederatedSettingsIdentityProviders#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers#idp_types DataMongodbatlasFederatedSettingsIdentityProviders#idp_types}
    */
    readonly idpTypes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers#protocols DataMongodbatlasFederatedSettingsIdentityProviders#protocols}
    */
    readonly protocols?: string[];
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignments {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignments): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignments): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignments | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignments | undefined);
    get groupId(): string;
    get orgId(): string;
    get role(): string;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappings {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappings): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappings): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappings | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappings | undefined);
    get externalGroupName(): string;
    get id(): string;
    private _roleAssignments;
    get roleAssignments(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsRoleAssignmentsList;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflicts {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflicts): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflicts): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflicts | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflicts | undefined);
    get emailAddress(): string;
    get federationSettingsId(): string;
    get firstName(): string;
    get lastName(): string;
    get userId(): string;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgs {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgs): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgs): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgs | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgs | undefined);
    get domainAllowList(): string[];
    get domainRestrictionEnabled(): cdktf.IResolvable;
    get identityProviderId(): string;
    get orgId(): string;
    get postAuthRoleGrants(): string[];
    private _roleMappings;
    get roleMappings(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsRoleMappingsList;
    private _userConflicts;
    get userConflicts(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsUserConflictsList;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificates {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificates): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificates): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificates | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificates | undefined);
    get notAfter(): string;
    get notBefore(): string;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfo {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfo): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfo): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfo | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfo | undefined);
    private _certificates;
    get certificates(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoCertificatesList;
    get fileName(): string;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoOutputReference;
}
export interface DataMongodbatlasFederatedSettingsIdentityProvidersResults {
}
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsToTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResults): any;
export declare function dataMongodbatlasFederatedSettingsIdentityProvidersResultsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsIdentityProvidersResults): any;
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsIdentityProvidersResults | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsIdentityProvidersResults | undefined);
    get acsUrl(): string;
    get associatedDomains(): string[];
    private _associatedOrgs;
    get associatedOrgs(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsAssociatedOrgsList;
    get audience(): string;
    get audienceUri(): string;
    get authorizationType(): string;
    get clientId(): string;
    get description(): string;
    get displayName(): string;
    get groupsClaim(): string;
    get idpId(): string;
    get idpType(): string;
    get issuerUri(): string;
    get oktaIdpId(): string;
    private _pemFileInfo;
    get pemFileInfo(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsPemFileInfoList;
    get protocol(): string;
    get requestBinding(): string;
    get requestedScopes(): string[];
    get responseSignatureAlgorithm(): string;
    get ssoDebugEnabled(): cdktf.IResolvable;
    get ssoUrl(): string;
    get status(): string;
    get userClaim(): string;
}
export declare class DataMongodbatlasFederatedSettingsIdentityProvidersResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsIdentityProvidersResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers mongodbatlas_federated_settings_identity_providers}
*/
export declare class DataMongodbatlasFederatedSettingsIdentityProviders extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_settings_identity_providers";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedSettingsIdentityProviders resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedSettingsIdentityProviders to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedSettingsIdentityProviders that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedSettingsIdentityProviders to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_identity_providers mongodbatlas_federated_settings_identity_providers} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedSettingsIdentityProvidersConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedSettingsIdentityProvidersConfig);
    private _federationSettingsId?;
    get federationSettingsId(): string;
    set federationSettingsId(value: string);
    get federationSettingsIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _idpTypes?;
    get idpTypes(): string[];
    set idpTypes(value: string[]);
    resetIdpTypes(): void;
    get idpTypesInput(): string[] | undefined;
    private _protocols?;
    get protocols(): string[];
    set protocols(value: string[]);
    resetProtocols(): void;
    get protocolsInput(): string[] | undefined;
    private _results;
    get results(): DataMongodbatlasFederatedSettingsIdentityProvidersResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
