/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedSettingsOrgConfigsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs#federation_settings_id DataMongodbatlasFederatedSettingsOrgConfigs#federation_settings_id}
    */
    readonly federationSettingsId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs#id DataMongodbatlasFederatedSettingsOrgConfigs#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs#items_per_page DataMongodbatlasFederatedSettingsOrgConfigs#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs#page_num DataMongodbatlasFederatedSettingsOrgConfigs#page_num}
    */
    readonly pageNum?: number;
}
export interface DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignments {
}
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignments): any;
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignments): any;
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignments | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignments | undefined);
    get groupId(): string;
    get orgId(): string;
    get role(): string;
}
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappings {
}
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappings): any;
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappings): any;
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappings | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappings | undefined);
    get externalGroupName(): string;
    get id(): string;
    private _roleAssignments;
    get roleAssignments(): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsRoleAssignmentsList;
}
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflicts {
}
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflicts): any;
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflicts): any;
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflicts | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflicts | undefined);
    get emailAddress(): string;
    get federationSettingsId(): string;
    get firstName(): string;
    get lastName(): string;
    get userId(): string;
}
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsOrgConfigsResults {
}
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResults): any;
export declare function dataMongodbatlasFederatedSettingsOrgConfigsResultsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgConfigsResults): any;
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgConfigsResults | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgConfigsResults | undefined);
    get dataAccessIdentityProviderIds(): string[];
    get domainAllowList(): string[];
    get domainRestrictionEnabled(): cdktf.IResolvable;
    get identityProviderId(): string;
    get orgId(): string;
    get postAuthRoleGrants(): string[];
    private _roleMappings;
    get roleMappings(): DataMongodbatlasFederatedSettingsOrgConfigsResultsRoleMappingsList;
    private _userConflicts;
    get userConflicts(): DataMongodbatlasFederatedSettingsOrgConfigsResultsUserConflictsList;
}
export declare class DataMongodbatlasFederatedSettingsOrgConfigsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgConfigsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs mongodbatlas_federated_settings_org_configs}
*/
export declare class DataMongodbatlasFederatedSettingsOrgConfigs extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_settings_org_configs";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedSettingsOrgConfigs resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedSettingsOrgConfigs to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedSettingsOrgConfigs that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedSettingsOrgConfigs to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_configs mongodbatlas_federated_settings_org_configs} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedSettingsOrgConfigsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedSettingsOrgConfigsConfig);
    private _federationSettingsId?;
    get federationSettingsId(): string;
    set federationSettingsId(value: string);
    get federationSettingsIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _results;
    get results(): DataMongodbatlasFederatedSettingsOrgConfigsResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
