/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedSettingsOrgRoleMappingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping#federation_settings_id DataMongodbatlasFederatedSettingsOrgRoleMapping#federation_settings_id}
    */
    readonly federationSettingsId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping#org_id DataMongodbatlasFederatedSettingsOrgRoleMapping#org_id}
    */
    readonly orgId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping#role_mapping_id DataMongodbatlasFederatedSettingsOrgRoleMapping#role_mapping_id}
    */
    readonly roleMappingId: string;
}
export interface DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignments {
}
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignments): any;
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignments): any;
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignments | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignments | undefined);
    get groupId(): string;
    get orgId(): string;
    get role(): string;
}
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping mongodbatlas_federated_settings_org_role_mapping}
*/
export declare class DataMongodbatlasFederatedSettingsOrgRoleMapping extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_settings_org_role_mapping";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedSettingsOrgRoleMapping resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedSettingsOrgRoleMapping to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedSettingsOrgRoleMapping that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedSettingsOrgRoleMapping to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mapping mongodbatlas_federated_settings_org_role_mapping} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedSettingsOrgRoleMappingConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedSettingsOrgRoleMappingConfig);
    get externalGroupName(): string;
    private _federationSettingsId?;
    get federationSettingsId(): string;
    set federationSettingsId(value: string);
    get federationSettingsIdInput(): string | undefined;
    get id(): string;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    private _roleAssignments;
    get roleAssignments(): DataMongodbatlasFederatedSettingsOrgRoleMappingRoleAssignmentsList;
    private _roleMappingId?;
    get roleMappingId(): string;
    set roleMappingId(value: string);
    get roleMappingIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
