/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFederatedSettingsOrgRoleMappingsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#federation_settings_id DataMongodbatlasFederatedSettingsOrgRoleMappings#federation_settings_id}
    */
    readonly federationSettingsId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#id DataMongodbatlasFederatedSettingsOrgRoleMappings#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#items_per_page DataMongodbatlasFederatedSettingsOrgRoleMappings#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#org_id DataMongodbatlasFederatedSettingsOrgRoleMappings#org_id}
    */
    readonly orgId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#page_num DataMongodbatlasFederatedSettingsOrgRoleMappings#page_num}
    */
    readonly pageNum?: number;
}
export interface DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignments {
}
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignments): any;
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignments): any;
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignments | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignments | undefined);
    get groupId(): string;
    get orgId(): string;
    get role(): string;
}
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsOutputReference;
}
export interface DataMongodbatlasFederatedSettingsOrgRoleMappingsResults {
}
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingsResultsToTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingsResults): any;
export declare function dataMongodbatlasFederatedSettingsOrgRoleMappingsResultsToHclTerraform(struct?: DataMongodbatlasFederatedSettingsOrgRoleMappingsResults): any;
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasFederatedSettingsOrgRoleMappingsResults | undefined;
    set internalValue(value: DataMongodbatlasFederatedSettingsOrgRoleMappingsResults | undefined);
    get externalGroupName(): string;
    get id(): string;
    private _roleAssignments;
    get roleAssignments(): DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsRoleAssignmentsList;
}
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings mongodbatlas_federated_settings_org_role_mappings}
*/
export declare class DataMongodbatlasFederatedSettingsOrgRoleMappings extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_federated_settings_org_role_mappings";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFederatedSettingsOrgRoleMappings resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFederatedSettingsOrgRoleMappings to import
    * @param importFromId The id of the existing DataMongodbatlasFederatedSettingsOrgRoleMappings that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFederatedSettingsOrgRoleMappings to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/federated_settings_org_role_mappings mongodbatlas_federated_settings_org_role_mappings} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFederatedSettingsOrgRoleMappingsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFederatedSettingsOrgRoleMappingsConfig);
    private _federationSettingsId?;
    get federationSettingsId(): string;
    set federationSettingsId(value: string);
    get federationSettingsIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _results;
    get results(): DataMongodbatlasFederatedSettingsOrgRoleMappingsResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
