/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasGlobalClusterConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#cluster_name DataMongodbatlasGlobalClusterConfig#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#id DataMongodbatlasGlobalClusterConfig#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#project_id DataMongodbatlasGlobalClusterConfig#project_id}
    */
    readonly projectId: string;
    /**
    * managed_namespaces block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#managed_namespaces DataMongodbatlasGlobalClusterConfig#managed_namespaces}
    */
    readonly managedNamespaces?: DataMongodbatlasGlobalClusterConfigManagedNamespaces[] | cdktf.IResolvable;
}
export interface DataMongodbatlasGlobalClusterConfigManagedNamespaces {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#collection DataMongodbatlasGlobalClusterConfig#collection}
    */
    readonly collection: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#custom_shard_key DataMongodbatlasGlobalClusterConfig#custom_shard_key}
    */
    readonly customShardKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#db DataMongodbatlasGlobalClusterConfig#db}
    */
    readonly db: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#is_custom_shard_key_hashed DataMongodbatlasGlobalClusterConfig#is_custom_shard_key_hashed}
    */
    readonly isCustomShardKeyHashed?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#is_shard_key_unique DataMongodbatlasGlobalClusterConfig#is_shard_key_unique}
    */
    readonly isShardKeyUnique?: boolean | cdktf.IResolvable;
}
export declare function dataMongodbatlasGlobalClusterConfigManagedNamespacesToTerraform(struct?: DataMongodbatlasGlobalClusterConfigManagedNamespaces | cdktf.IResolvable): any;
export declare function dataMongodbatlasGlobalClusterConfigManagedNamespacesToHclTerraform(struct?: DataMongodbatlasGlobalClusterConfigManagedNamespaces | cdktf.IResolvable): any;
export declare class DataMongodbatlasGlobalClusterConfigManagedNamespacesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasGlobalClusterConfigManagedNamespaces | cdktf.IResolvable | undefined;
    set internalValue(value: DataMongodbatlasGlobalClusterConfigManagedNamespaces | cdktf.IResolvable | undefined);
    private _collection?;
    get collection(): string;
    set collection(value: string);
    get collectionInput(): string | undefined;
    private _customShardKey?;
    get customShardKey(): string;
    set customShardKey(value: string);
    get customShardKeyInput(): string | undefined;
    private _db?;
    get db(): string;
    set db(value: string);
    get dbInput(): string | undefined;
    private _isCustomShardKeyHashed?;
    get isCustomShardKeyHashed(): boolean | cdktf.IResolvable;
    set isCustomShardKeyHashed(value: boolean | cdktf.IResolvable);
    resetIsCustomShardKeyHashed(): void;
    get isCustomShardKeyHashedInput(): boolean | cdktf.IResolvable | undefined;
    private _isShardKeyUnique?;
    get isShardKeyUnique(): boolean | cdktf.IResolvable;
    set isShardKeyUnique(value: boolean | cdktf.IResolvable);
    resetIsShardKeyUnique(): void;
    get isShardKeyUniqueInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class DataMongodbatlasGlobalClusterConfigManagedNamespacesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataMongodbatlasGlobalClusterConfigManagedNamespaces[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasGlobalClusterConfigManagedNamespacesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config mongodbatlas_global_cluster_config}
*/
export declare class DataMongodbatlasGlobalClusterConfig extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_global_cluster_config";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasGlobalClusterConfig resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasGlobalClusterConfig to import
    * @param importFromId The id of the existing DataMongodbatlasGlobalClusterConfig that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasGlobalClusterConfig to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/global_cluster_config mongodbatlas_global_cluster_config} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasGlobalClusterConfigConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasGlobalClusterConfigConfig);
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    private _customZoneMapping;
    get customZoneMapping(): cdktf.StringMap;
    private _customZoneMappingZoneId;
    get customZoneMappingZoneId(): cdktf.StringMap;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _managedNamespaces;
    get managedNamespaces(): DataMongodbatlasGlobalClusterConfigManagedNamespacesList;
    putManagedNamespaces(value: DataMongodbatlasGlobalClusterConfigManagedNamespaces[] | cdktf.IResolvable): void;
    resetManagedNamespaces(): void;
    get managedNamespacesInput(): cdktf.IResolvable | DataMongodbatlasGlobalClusterConfigManagedNamespaces[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
