/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasOnlineArchivesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives#cluster_name DataMongodbatlasOnlineArchives#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives#id DataMongodbatlasOnlineArchives#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives#project_id DataMongodbatlasOnlineArchives#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasOnlineArchivesResultsCriteria {
}
export declare function dataMongodbatlasOnlineArchivesResultsCriteriaToTerraform(struct?: DataMongodbatlasOnlineArchivesResultsCriteria): any;
export declare function dataMongodbatlasOnlineArchivesResultsCriteriaToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResultsCriteria): any;
export declare class DataMongodbatlasOnlineArchivesResultsCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResultsCriteria | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResultsCriteria | undefined);
    get dateField(): string;
    get dateFormat(): string;
    get expireAfterDays(): number;
    get query(): string;
    get type(): string;
}
export declare class DataMongodbatlasOnlineArchivesResultsCriteriaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsCriteriaOutputReference;
}
export interface DataMongodbatlasOnlineArchivesResultsDataExpirationRule {
}
export declare function dataMongodbatlasOnlineArchivesResultsDataExpirationRuleToTerraform(struct?: DataMongodbatlasOnlineArchivesResultsDataExpirationRule): any;
export declare function dataMongodbatlasOnlineArchivesResultsDataExpirationRuleToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResultsDataExpirationRule): any;
export declare class DataMongodbatlasOnlineArchivesResultsDataExpirationRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResultsDataExpirationRule | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResultsDataExpirationRule | undefined);
    get expireAfterDays(): number;
}
export declare class DataMongodbatlasOnlineArchivesResultsDataExpirationRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsDataExpirationRuleOutputReference;
}
export interface DataMongodbatlasOnlineArchivesResultsDataProcessRegion {
}
export declare function dataMongodbatlasOnlineArchivesResultsDataProcessRegionToTerraform(struct?: DataMongodbatlasOnlineArchivesResultsDataProcessRegion): any;
export declare function dataMongodbatlasOnlineArchivesResultsDataProcessRegionToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResultsDataProcessRegion): any;
export declare class DataMongodbatlasOnlineArchivesResultsDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResultsDataProcessRegion | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResultsDataProcessRegion | undefined);
    get cloudProvider(): string;
    get region(): string;
}
export declare class DataMongodbatlasOnlineArchivesResultsDataProcessRegionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsDataProcessRegionOutputReference;
}
export interface DataMongodbatlasOnlineArchivesResultsPartitionFields {
}
export declare function dataMongodbatlasOnlineArchivesResultsPartitionFieldsToTerraform(struct?: DataMongodbatlasOnlineArchivesResultsPartitionFields): any;
export declare function dataMongodbatlasOnlineArchivesResultsPartitionFieldsToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResultsPartitionFields): any;
export declare class DataMongodbatlasOnlineArchivesResultsPartitionFieldsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResultsPartitionFields | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResultsPartitionFields | undefined);
    get fieldName(): string;
    get fieldType(): string;
    get order(): number;
}
export declare class DataMongodbatlasOnlineArchivesResultsPartitionFieldsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsPartitionFieldsOutputReference;
}
export interface DataMongodbatlasOnlineArchivesResultsSchedule {
}
export declare function dataMongodbatlasOnlineArchivesResultsScheduleToTerraform(struct?: DataMongodbatlasOnlineArchivesResultsSchedule): any;
export declare function dataMongodbatlasOnlineArchivesResultsScheduleToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResultsSchedule): any;
export declare class DataMongodbatlasOnlineArchivesResultsScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResultsSchedule | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResultsSchedule | undefined);
    get dayOfMonth(): number;
    get dayOfWeek(): number;
    get endHour(): number;
    get endMinute(): number;
    get startHour(): number;
    get startMinute(): number;
    get type(): string;
}
export declare class DataMongodbatlasOnlineArchivesResultsScheduleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsScheduleOutputReference;
}
export interface DataMongodbatlasOnlineArchivesResults {
}
export declare function dataMongodbatlasOnlineArchivesResultsToTerraform(struct?: DataMongodbatlasOnlineArchivesResults): any;
export declare function dataMongodbatlasOnlineArchivesResultsToHclTerraform(struct?: DataMongodbatlasOnlineArchivesResults): any;
export declare class DataMongodbatlasOnlineArchivesResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasOnlineArchivesResults | undefined;
    set internalValue(value: DataMongodbatlasOnlineArchivesResults | undefined);
    get archiveId(): string;
    get clusterName(): string;
    get collName(): string;
    get collectionType(): string;
    private _criteria;
    get criteria(): DataMongodbatlasOnlineArchivesResultsCriteriaList;
    private _dataExpirationRule;
    get dataExpirationRule(): DataMongodbatlasOnlineArchivesResultsDataExpirationRuleList;
    private _dataProcessRegion;
    get dataProcessRegion(): DataMongodbatlasOnlineArchivesResultsDataProcessRegionList;
    get dbName(): string;
    private _partitionFields;
    get partitionFields(): DataMongodbatlasOnlineArchivesResultsPartitionFieldsList;
    get paused(): cdktf.IResolvable;
    get projectId(): string;
    private _schedule;
    get schedule(): DataMongodbatlasOnlineArchivesResultsScheduleList;
    get state(): string;
}
export declare class DataMongodbatlasOnlineArchivesResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasOnlineArchivesResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives mongodbatlas_online_archives}
*/
export declare class DataMongodbatlasOnlineArchives extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_online_archives";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasOnlineArchives resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasOnlineArchives to import
    * @param importFromId The id of the existing DataMongodbatlasOnlineArchives that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasOnlineArchives to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/online_archives mongodbatlas_online_archives} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasOnlineArchivesConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasOnlineArchivesConfig);
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasOnlineArchivesResultsList;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
