/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasProjectApiKeysConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys#id DataMongodbatlasProjectApiKeys#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys#items_per_page DataMongodbatlasProjectApiKeys#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys#page_num DataMongodbatlasProjectApiKeys#page_num}
    */
    readonly pageNum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys#project_id DataMongodbatlasProjectApiKeys#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasProjectApiKeysResultsProjectAssignment {
}
export declare function dataMongodbatlasProjectApiKeysResultsProjectAssignmentToTerraform(struct?: DataMongodbatlasProjectApiKeysResultsProjectAssignment): any;
export declare function dataMongodbatlasProjectApiKeysResultsProjectAssignmentToHclTerraform(struct?: DataMongodbatlasProjectApiKeysResultsProjectAssignment): any;
export declare class DataMongodbatlasProjectApiKeysResultsProjectAssignmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectApiKeysResultsProjectAssignment | undefined;
    set internalValue(value: DataMongodbatlasProjectApiKeysResultsProjectAssignment | undefined);
    get projectId(): string;
    get roleNames(): string[];
}
export declare class DataMongodbatlasProjectApiKeysResultsProjectAssignmentList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectApiKeysResultsProjectAssignmentOutputReference;
}
export interface DataMongodbatlasProjectApiKeysResults {
}
export declare function dataMongodbatlasProjectApiKeysResultsToTerraform(struct?: DataMongodbatlasProjectApiKeysResults): any;
export declare function dataMongodbatlasProjectApiKeysResultsToHclTerraform(struct?: DataMongodbatlasProjectApiKeysResults): any;
export declare class DataMongodbatlasProjectApiKeysResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectApiKeysResults | undefined;
    set internalValue(value: DataMongodbatlasProjectApiKeysResults | undefined);
    get apiKeyId(): string;
    get description(): string;
    get privateKey(): string;
    private _projectAssignment;
    get projectAssignment(): DataMongodbatlasProjectApiKeysResultsProjectAssignmentList;
    get publicKey(): string;
}
export declare class DataMongodbatlasProjectApiKeysResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectApiKeysResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys mongodbatlas_project_api_keys}
*/
export declare class DataMongodbatlasProjectApiKeys extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_project_api_keys";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasProjectApiKeys resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasProjectApiKeys to import
    * @param importFromId The id of the existing DataMongodbatlasProjectApiKeys that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasProjectApiKeys to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_api_keys mongodbatlas_project_api_keys} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasProjectApiKeysConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasProjectApiKeysConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasProjectApiKeysResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
