/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasProjectIpAddressesAConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique 24-hexadecimal digit string that identifies your project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_ip_addresses#project_id DataMongodbatlasProjectIpAddressesA#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasProjectIpAddressesServicesClustersA {
}
export declare function dataMongodbatlasProjectIpAddressesServicesClustersAToTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesClustersA): any;
export declare function dataMongodbatlasProjectIpAddressesServicesClustersAToHclTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesClustersA): any;
export declare class DataMongodbatlasProjectIpAddressesServicesClustersAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectIpAddressesServicesClustersA | undefined;
    set internalValue(value: DataMongodbatlasProjectIpAddressesServicesClustersA | undefined);
    get clusterName(): string;
    get inbound(): string[];
    get outbound(): string[];
}
export declare class DataMongodbatlasProjectIpAddressesServicesClustersAList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectIpAddressesServicesClustersAOutputReference;
}
export interface DataMongodbatlasProjectIpAddressesServicesA {
}
export declare function dataMongodbatlasProjectIpAddressesServicesAToTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesA): any;
export declare function dataMongodbatlasProjectIpAddressesServicesAToHclTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesA): any;
export declare class DataMongodbatlasProjectIpAddressesServicesAOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasProjectIpAddressesServicesA | undefined;
    set internalValue(value: DataMongodbatlasProjectIpAddressesServicesA | undefined);
    private _clusters;
    get clusters(): DataMongodbatlasProjectIpAddressesServicesClustersAList;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_ip_addresses mongodbatlas_project_ip_addresses}
*/
export declare class DataMongodbatlasProjectIpAddressesA extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_project_ip_addresses";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasProjectIpAddressesA resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasProjectIpAddressesA to import
    * @param importFromId The id of the existing DataMongodbatlasProjectIpAddressesA that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_ip_addresses#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasProjectIpAddressesA to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project_ip_addresses mongodbatlas_project_ip_addresses} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasProjectIpAddressesAConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasProjectIpAddressesAConfig);
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _services;
    get services(): DataMongodbatlasProjectIpAddressesServicesAOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
