/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasProjectConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project#name DataMongodbatlasProject#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project#project_id DataMongodbatlasProject#project_id}
    */
    readonly projectId?: string;
}
export interface DataMongodbatlasProjectIpAddressesServicesClusters {
}
export declare function dataMongodbatlasProjectIpAddressesServicesClustersToTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesClusters): any;
export declare function dataMongodbatlasProjectIpAddressesServicesClustersToHclTerraform(struct?: DataMongodbatlasProjectIpAddressesServicesClusters): any;
export declare class DataMongodbatlasProjectIpAddressesServicesClustersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectIpAddressesServicesClusters | undefined;
    set internalValue(value: DataMongodbatlasProjectIpAddressesServicesClusters | undefined);
    get clusterName(): string;
    get inbound(): string[];
    get outbound(): string[];
}
export declare class DataMongodbatlasProjectIpAddressesServicesClustersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectIpAddressesServicesClustersOutputReference;
}
export interface DataMongodbatlasProjectIpAddressesServices {
}
export declare function dataMongodbatlasProjectIpAddressesServicesToTerraform(struct?: DataMongodbatlasProjectIpAddressesServices): any;
export declare function dataMongodbatlasProjectIpAddressesServicesToHclTerraform(struct?: DataMongodbatlasProjectIpAddressesServices): any;
export declare class DataMongodbatlasProjectIpAddressesServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasProjectIpAddressesServices | undefined;
    set internalValue(value: DataMongodbatlasProjectIpAddressesServices | undefined);
    private _clusters;
    get clusters(): DataMongodbatlasProjectIpAddressesServicesClustersList;
}
export interface DataMongodbatlasProjectIpAddresses {
}
export declare function dataMongodbatlasProjectIpAddressesToTerraform(struct?: DataMongodbatlasProjectIpAddresses): any;
export declare function dataMongodbatlasProjectIpAddressesToHclTerraform(struct?: DataMongodbatlasProjectIpAddresses): any;
export declare class DataMongodbatlasProjectIpAddressesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasProjectIpAddresses | undefined;
    set internalValue(value: DataMongodbatlasProjectIpAddresses | undefined);
    private _services;
    get services(): DataMongodbatlasProjectIpAddressesServicesOutputReference;
}
export interface DataMongodbatlasProjectLimits {
}
export declare function dataMongodbatlasProjectLimitsToTerraform(struct?: DataMongodbatlasProjectLimits): any;
export declare function dataMongodbatlasProjectLimitsToHclTerraform(struct?: DataMongodbatlasProjectLimits): any;
export declare class DataMongodbatlasProjectLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectLimits | undefined;
    set internalValue(value: DataMongodbatlasProjectLimits | undefined);
    get currentUsage(): number;
    get defaultLimit(): number;
    get maximumLimit(): number;
    get name(): string;
    get value(): number;
}
export declare class DataMongodbatlasProjectLimitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectLimitsOutputReference;
}
export interface DataMongodbatlasProjectTeams {
}
export declare function dataMongodbatlasProjectTeamsToTerraform(struct?: DataMongodbatlasProjectTeams): any;
export declare function dataMongodbatlasProjectTeamsToHclTerraform(struct?: DataMongodbatlasProjectTeams): any;
export declare class DataMongodbatlasProjectTeamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectTeams | undefined;
    set internalValue(value: DataMongodbatlasProjectTeams | undefined);
    get roleNames(): string[];
    get teamId(): string;
}
export declare class DataMongodbatlasProjectTeamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectTeamsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project mongodbatlas_project}
*/
export declare class DataMongodbatlasProject extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_project";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasProject resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasProject to import
    * @param importFromId The id of the existing DataMongodbatlasProject that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasProject to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/project mongodbatlas_project} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasProjectConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataMongodbatlasProjectConfig);
    get clusterCount(): number;
    get created(): string;
    get id(): string;
    private _ipAddresses;
    get ipAddresses(): DataMongodbatlasProjectIpAddressesOutputReference;
    get isCollectDatabaseSpecificsStatisticsEnabled(): cdktf.IResolvable;
    get isDataExplorerEnabled(): cdktf.IResolvable;
    get isExtendedStorageSizesEnabled(): cdktf.IResolvable;
    get isPerformanceAdvisorEnabled(): cdktf.IResolvable;
    get isRealtimePerformancePanelEnabled(): cdktf.IResolvable;
    get isSchemaAdvisorEnabled(): cdktf.IResolvable;
    private _limits;
    get limits(): DataMongodbatlasProjectLimitsList;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    get orgId(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    resetProjectId(): void;
    get projectIdInput(): string | undefined;
    get regionUsageRestrictions(): string;
    private _tags;
    get tags(): cdktf.StringMap;
    private _teams;
    get teams(): DataMongodbatlasProjectTeamsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
