/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasProjectsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/projects#items_per_page DataMongodbatlasProjects#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/projects#page_num DataMongodbatlasProjects#page_num}
    */
    readonly pageNum?: number;
}
export interface DataMongodbatlasProjectsResultsIpAddressesServicesClusters {
}
export declare function dataMongodbatlasProjectsResultsIpAddressesServicesClustersToTerraform(struct?: DataMongodbatlasProjectsResultsIpAddressesServicesClusters): any;
export declare function dataMongodbatlasProjectsResultsIpAddressesServicesClustersToHclTerraform(struct?: DataMongodbatlasProjectsResultsIpAddressesServicesClusters): any;
export declare class DataMongodbatlasProjectsResultsIpAddressesServicesClustersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectsResultsIpAddressesServicesClusters | undefined;
    set internalValue(value: DataMongodbatlasProjectsResultsIpAddressesServicesClusters | undefined);
    get clusterName(): string;
    get inbound(): string[];
    get outbound(): string[];
}
export declare class DataMongodbatlasProjectsResultsIpAddressesServicesClustersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectsResultsIpAddressesServicesClustersOutputReference;
}
export interface DataMongodbatlasProjectsResultsIpAddressesServices {
}
export declare function dataMongodbatlasProjectsResultsIpAddressesServicesToTerraform(struct?: DataMongodbatlasProjectsResultsIpAddressesServices): any;
export declare function dataMongodbatlasProjectsResultsIpAddressesServicesToHclTerraform(struct?: DataMongodbatlasProjectsResultsIpAddressesServices): any;
export declare class DataMongodbatlasProjectsResultsIpAddressesServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasProjectsResultsIpAddressesServices | undefined;
    set internalValue(value: DataMongodbatlasProjectsResultsIpAddressesServices | undefined);
    private _clusters;
    get clusters(): DataMongodbatlasProjectsResultsIpAddressesServicesClustersList;
}
export interface DataMongodbatlasProjectsResultsIpAddresses {
}
export declare function dataMongodbatlasProjectsResultsIpAddressesToTerraform(struct?: DataMongodbatlasProjectsResultsIpAddresses): any;
export declare function dataMongodbatlasProjectsResultsIpAddressesToHclTerraform(struct?: DataMongodbatlasProjectsResultsIpAddresses): any;
export declare class DataMongodbatlasProjectsResultsIpAddressesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasProjectsResultsIpAddresses | undefined;
    set internalValue(value: DataMongodbatlasProjectsResultsIpAddresses | undefined);
    private _services;
    get services(): DataMongodbatlasProjectsResultsIpAddressesServicesOutputReference;
}
export interface DataMongodbatlasProjectsResultsLimits {
}
export declare function dataMongodbatlasProjectsResultsLimitsToTerraform(struct?: DataMongodbatlasProjectsResultsLimits): any;
export declare function dataMongodbatlasProjectsResultsLimitsToHclTerraform(struct?: DataMongodbatlasProjectsResultsLimits): any;
export declare class DataMongodbatlasProjectsResultsLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectsResultsLimits | undefined;
    set internalValue(value: DataMongodbatlasProjectsResultsLimits | undefined);
    get currentUsage(): number;
    get defaultLimit(): number;
    get maximumLimit(): number;
    get name(): string;
    get value(): number;
}
export declare class DataMongodbatlasProjectsResultsLimitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectsResultsLimitsOutputReference;
}
export interface DataMongodbatlasProjectsResultsTeams {
}
export declare function dataMongodbatlasProjectsResultsTeamsToTerraform(struct?: DataMongodbatlasProjectsResultsTeams): any;
export declare function dataMongodbatlasProjectsResultsTeamsToHclTerraform(struct?: DataMongodbatlasProjectsResultsTeams): any;
export declare class DataMongodbatlasProjectsResultsTeamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectsResultsTeams | undefined;
    set internalValue(value: DataMongodbatlasProjectsResultsTeams | undefined);
    get roleNames(): string[];
    get teamId(): string;
}
export declare class DataMongodbatlasProjectsResultsTeamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectsResultsTeamsOutputReference;
}
export interface DataMongodbatlasProjectsResults {
}
export declare function dataMongodbatlasProjectsResultsToTerraform(struct?: DataMongodbatlasProjectsResults): any;
export declare function dataMongodbatlasProjectsResultsToHclTerraform(struct?: DataMongodbatlasProjectsResults): any;
export declare class DataMongodbatlasProjectsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasProjectsResults | undefined;
    set internalValue(value: DataMongodbatlasProjectsResults | undefined);
    get clusterCount(): number;
    get created(): string;
    get id(): string;
    private _ipAddresses;
    get ipAddresses(): DataMongodbatlasProjectsResultsIpAddressesOutputReference;
    get isCollectDatabaseSpecificsStatisticsEnabled(): cdktf.IResolvable;
    get isDataExplorerEnabled(): cdktf.IResolvable;
    get isExtendedStorageSizesEnabled(): cdktf.IResolvable;
    get isPerformanceAdvisorEnabled(): cdktf.IResolvable;
    get isRealtimePerformancePanelEnabled(): cdktf.IResolvable;
    get isSchemaAdvisorEnabled(): cdktf.IResolvable;
    private _limits;
    get limits(): DataMongodbatlasProjectsResultsLimitsList;
    get name(): string;
    get orgId(): string;
    get projectId(): string;
    get regionUsageRestrictions(): string;
    private _tags;
    get tags(): cdktf.StringMap;
    private _teams;
    get teams(): DataMongodbatlasProjectsResultsTeamsList;
}
export declare class DataMongodbatlasProjectsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasProjectsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/projects mongodbatlas_projects}
*/
export declare class DataMongodbatlasProjects extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_projects";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasProjects resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasProjects to import
    * @param importFromId The id of the existing DataMongodbatlasProjects that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/projects#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasProjects to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/projects mongodbatlas_projects} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasProjectsConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataMongodbatlasProjectsConfig);
    get id(): string;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _results;
    get results(): DataMongodbatlasProjectsResultsList;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
