/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasSearchDeploymentConfig extends cdktf.TerraformMetaArguments {
    /**
    * Label that identifies the cluster to return the search nodes for.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/search_deployment#cluster_name DataMongodbatlasSearchDeployment#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Unique 24-hexadecimal digit string that identifies your project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/search_deployment#project_id DataMongodbatlasSearchDeployment#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasSearchDeploymentSpecs {
}
export declare function dataMongodbatlasSearchDeploymentSpecsToTerraform(struct?: DataMongodbatlasSearchDeploymentSpecs): any;
export declare function dataMongodbatlasSearchDeploymentSpecsToHclTerraform(struct?: DataMongodbatlasSearchDeploymentSpecs): any;
export declare class DataMongodbatlasSearchDeploymentSpecsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasSearchDeploymentSpecs | undefined;
    set internalValue(value: DataMongodbatlasSearchDeploymentSpecs | undefined);
    get instanceSize(): string;
    get nodeCount(): number;
}
export declare class DataMongodbatlasSearchDeploymentSpecsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasSearchDeploymentSpecsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/search_deployment mongodbatlas_search_deployment}
*/
export declare class DataMongodbatlasSearchDeployment extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_search_deployment";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasSearchDeployment resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasSearchDeployment to import
    * @param importFromId The id of the existing DataMongodbatlasSearchDeployment that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/search_deployment#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasSearchDeployment to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/search_deployment mongodbatlas_search_deployment} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasSearchDeploymentConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasSearchDeploymentConfig);
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    get id(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _specs;
    get specs(): DataMongodbatlasSearchDeploymentSpecsList;
    get stateName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
