/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasStreamConnectionsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections#instance_name DataMongodbatlasStreamConnections#instance_name}
    */
    readonly instanceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections#items_per_page DataMongodbatlasStreamConnections#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections#page_num DataMongodbatlasStreamConnections#page_num}
    */
    readonly pageNum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections#project_id DataMongodbatlasStreamConnections#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasStreamConnectionsResultsAuthentication {
}
export declare function dataMongodbatlasStreamConnectionsResultsAuthenticationToTerraform(struct?: DataMongodbatlasStreamConnectionsResultsAuthentication): any;
export declare function dataMongodbatlasStreamConnectionsResultsAuthenticationToHclTerraform(struct?: DataMongodbatlasStreamConnectionsResultsAuthentication): any;
export declare class DataMongodbatlasStreamConnectionsResultsAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionsResultsAuthentication | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionsResultsAuthentication | undefined);
    get mechanism(): string;
    get password(): string;
    get username(): string;
}
export interface DataMongodbatlasStreamConnectionsResultsDbRoleToExecute {
}
export declare function dataMongodbatlasStreamConnectionsResultsDbRoleToExecuteToTerraform(struct?: DataMongodbatlasStreamConnectionsResultsDbRoleToExecute): any;
export declare function dataMongodbatlasStreamConnectionsResultsDbRoleToExecuteToHclTerraform(struct?: DataMongodbatlasStreamConnectionsResultsDbRoleToExecute): any;
export declare class DataMongodbatlasStreamConnectionsResultsDbRoleToExecuteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionsResultsDbRoleToExecute | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionsResultsDbRoleToExecute | undefined);
    get role(): string;
    get type(): string;
}
export interface DataMongodbatlasStreamConnectionsResultsSecurity {
}
export declare function dataMongodbatlasStreamConnectionsResultsSecurityToTerraform(struct?: DataMongodbatlasStreamConnectionsResultsSecurity): any;
export declare function dataMongodbatlasStreamConnectionsResultsSecurityToHclTerraform(struct?: DataMongodbatlasStreamConnectionsResultsSecurity): any;
export declare class DataMongodbatlasStreamConnectionsResultsSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamConnectionsResultsSecurity | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionsResultsSecurity | undefined);
    get brokerPublicCertificate(): string;
    get protocol(): string;
}
export interface DataMongodbatlasStreamConnectionsResults {
}
export declare function dataMongodbatlasStreamConnectionsResultsToTerraform(struct?: DataMongodbatlasStreamConnectionsResults): any;
export declare function dataMongodbatlasStreamConnectionsResultsToHclTerraform(struct?: DataMongodbatlasStreamConnectionsResults): any;
export declare class DataMongodbatlasStreamConnectionsResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasStreamConnectionsResults | undefined;
    set internalValue(value: DataMongodbatlasStreamConnectionsResults | undefined);
    private _authentication;
    get authentication(): DataMongodbatlasStreamConnectionsResultsAuthenticationOutputReference;
    get bootstrapServers(): string;
    get clusterName(): string;
    private _config;
    get config(): cdktf.StringMap;
    get connectionName(): string;
    private _dbRoleToExecute;
    get dbRoleToExecute(): DataMongodbatlasStreamConnectionsResultsDbRoleToExecuteOutputReference;
    get id(): string;
    get instanceName(): string;
    get projectId(): string;
    private _security;
    get security(): DataMongodbatlasStreamConnectionsResultsSecurityOutputReference;
    get type(): string;
}
export declare class DataMongodbatlasStreamConnectionsResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasStreamConnectionsResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections mongodbatlas_stream_connections}
*/
export declare class DataMongodbatlasStreamConnections extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_stream_connections";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasStreamConnections resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasStreamConnections to import
    * @param importFromId The id of the existing DataMongodbatlasStreamConnections that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasStreamConnections to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_connections mongodbatlas_stream_connections} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasStreamConnectionsConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasStreamConnectionsConfig);
    get id(): string;
    private _instanceName?;
    get instanceName(): string;
    set instanceName(value: string);
    get instanceNameInput(): string | undefined;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasStreamConnectionsResultsList;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
