/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasStreamInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instance#instance_name DataMongodbatlasStreamInstance#instance_name}
    */
    readonly instanceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instance#project_id DataMongodbatlasStreamInstance#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasStreamInstanceDataProcessRegion {
}
export declare function dataMongodbatlasStreamInstanceDataProcessRegionToTerraform(struct?: DataMongodbatlasStreamInstanceDataProcessRegion): any;
export declare function dataMongodbatlasStreamInstanceDataProcessRegionToHclTerraform(struct?: DataMongodbatlasStreamInstanceDataProcessRegion): any;
export declare class DataMongodbatlasStreamInstanceDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamInstanceDataProcessRegion | undefined;
    set internalValue(value: DataMongodbatlasStreamInstanceDataProcessRegion | undefined);
    get cloudProvider(): string;
    get region(): string;
}
export interface DataMongodbatlasStreamInstanceStreamConfig {
}
export declare function dataMongodbatlasStreamInstanceStreamConfigToTerraform(struct?: DataMongodbatlasStreamInstanceStreamConfig): any;
export declare function dataMongodbatlasStreamInstanceStreamConfigToHclTerraform(struct?: DataMongodbatlasStreamInstanceStreamConfig): any;
export declare class DataMongodbatlasStreamInstanceStreamConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamInstanceStreamConfig | undefined;
    set internalValue(value: DataMongodbatlasStreamInstanceStreamConfig | undefined);
    get tier(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instance mongodbatlas_stream_instance}
*/
export declare class DataMongodbatlasStreamInstance extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_stream_instance";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasStreamInstance resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasStreamInstance to import
    * @param importFromId The id of the existing DataMongodbatlasStreamInstance that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instance#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasStreamInstance to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instance mongodbatlas_stream_instance} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasStreamInstanceConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasStreamInstanceConfig);
    private _dataProcessRegion;
    get dataProcessRegion(): DataMongodbatlasStreamInstanceDataProcessRegionOutputReference;
    get hostnames(): string[];
    get id(): string;
    private _instanceName?;
    get instanceName(): string;
    set instanceName(value: string);
    get instanceNameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _streamConfig;
    get streamConfig(): DataMongodbatlasStreamInstanceStreamConfigOutputReference;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
