/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasStreamInstancesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances#items_per_page DataMongodbatlasStreamInstances#items_per_page}
    */
    readonly itemsPerPage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances#page_num DataMongodbatlasStreamInstances#page_num}
    */
    readonly pageNum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances#project_id DataMongodbatlasStreamInstances#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasStreamInstancesResultsDataProcessRegion {
}
export declare function dataMongodbatlasStreamInstancesResultsDataProcessRegionToTerraform(struct?: DataMongodbatlasStreamInstancesResultsDataProcessRegion): any;
export declare function dataMongodbatlasStreamInstancesResultsDataProcessRegionToHclTerraform(struct?: DataMongodbatlasStreamInstancesResultsDataProcessRegion): any;
export declare class DataMongodbatlasStreamInstancesResultsDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamInstancesResultsDataProcessRegion | undefined;
    set internalValue(value: DataMongodbatlasStreamInstancesResultsDataProcessRegion | undefined);
    get cloudProvider(): string;
    get region(): string;
}
export interface DataMongodbatlasStreamInstancesResultsStreamConfig {
}
export declare function dataMongodbatlasStreamInstancesResultsStreamConfigToTerraform(struct?: DataMongodbatlasStreamInstancesResultsStreamConfig): any;
export declare function dataMongodbatlasStreamInstancesResultsStreamConfigToHclTerraform(struct?: DataMongodbatlasStreamInstancesResultsStreamConfig): any;
export declare class DataMongodbatlasStreamInstancesResultsStreamConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasStreamInstancesResultsStreamConfig | undefined;
    set internalValue(value: DataMongodbatlasStreamInstancesResultsStreamConfig | undefined);
    get tier(): string;
}
export interface DataMongodbatlasStreamInstancesResults {
}
export declare function dataMongodbatlasStreamInstancesResultsToTerraform(struct?: DataMongodbatlasStreamInstancesResults): any;
export declare function dataMongodbatlasStreamInstancesResultsToHclTerraform(struct?: DataMongodbatlasStreamInstancesResults): any;
export declare class DataMongodbatlasStreamInstancesResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasStreamInstancesResults | undefined;
    set internalValue(value: DataMongodbatlasStreamInstancesResults | undefined);
    private _dataProcessRegion;
    get dataProcessRegion(): DataMongodbatlasStreamInstancesResultsDataProcessRegionOutputReference;
    get hostnames(): string[];
    get id(): string;
    get instanceName(): string;
    get projectId(): string;
    private _streamConfig;
    get streamConfig(): DataMongodbatlasStreamInstancesResultsStreamConfigOutputReference;
}
export declare class DataMongodbatlasStreamInstancesResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasStreamInstancesResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances mongodbatlas_stream_instances}
*/
export declare class DataMongodbatlasStreamInstances extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_stream_instances";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasStreamInstances resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasStreamInstances to import
    * @param importFromId The id of the existing DataMongodbatlasStreamInstances that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasStreamInstances to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/data-sources/stream_instances mongodbatlas_stream_instances} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasStreamInstancesConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasStreamInstancesConfig);
    get id(): string;
    private _itemsPerPage?;
    get itemsPerPage(): number;
    set itemsPerPage(value: number);
    resetItemsPerPage(): void;
    get itemsPerPageInput(): number | undefined;
    private _pageNum?;
    get pageNum(): number;
    set pageNum(value: number);
    resetPageNum(): void;
    get pageNumInput(): number | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _results;
    get results(): DataMongodbatlasStreamInstancesResultsList;
    get totalCount(): number;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
