/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface FederatedQueryLimitConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#default_limit FederatedQueryLimit#default_limit}
    */
    readonly defaultLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#id FederatedQueryLimit#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#limit_name FederatedQueryLimit#limit_name}
    */
    readonly limitName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#maximum_limit FederatedQueryLimit#maximum_limit}
    */
    readonly maximumLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#overrun_policy FederatedQueryLimit#overrun_policy}
    */
    readonly overrunPolicy: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#project_id FederatedQueryLimit#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#tenant_name FederatedQueryLimit#tenant_name}
    */
    readonly tenantName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#value FederatedQueryLimit#value}
    */
    readonly value: number;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit mongodbatlas_federated_query_limit}
*/
export declare class FederatedQueryLimit extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_federated_query_limit";
    /**
    * Generates CDKTF code for importing a FederatedQueryLimit resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the FederatedQueryLimit to import
    * @param importFromId The id of the existing FederatedQueryLimit that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the FederatedQueryLimit to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_query_limit mongodbatlas_federated_query_limit} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options FederatedQueryLimitConfig
    */
    constructor(scope: Construct, id: string, config: FederatedQueryLimitConfig);
    get currentUsage(): number;
    private _defaultLimit?;
    get defaultLimit(): number;
    set defaultLimit(value: number);
    resetDefaultLimit(): void;
    get defaultLimitInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get lastModifiedDate(): string;
    private _limitName?;
    get limitName(): string;
    set limitName(value: string);
    get limitNameInput(): string | undefined;
    private _maximumLimit?;
    get maximumLimit(): number;
    set maximumLimit(value: number);
    resetMaximumLimit(): void;
    get maximumLimitInput(): number | undefined;
    private _overrunPolicy?;
    get overrunPolicy(): string;
    set overrunPolicy(value: string);
    get overrunPolicyInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _tenantName?;
    get tenantName(): string;
    set tenantName(value: string);
    get tenantNameInput(): string | undefined;
    private _value?;
    get value(): number;
    set value(value: number);
    get valueInput(): number | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
