/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface FederatedSettingsOrgConfigConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#data_access_identity_provider_ids FederatedSettingsOrgConfig#data_access_identity_provider_ids}
    */
    readonly dataAccessIdentityProviderIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#domain_allow_list FederatedSettingsOrgConfig#domain_allow_list}
    */
    readonly domainAllowList?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#domain_restriction_enabled FederatedSettingsOrgConfig#domain_restriction_enabled}
    */
    readonly domainRestrictionEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#federation_settings_id FederatedSettingsOrgConfig#federation_settings_id}
    */
    readonly federationSettingsId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#id FederatedSettingsOrgConfig#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#identity_provider_id FederatedSettingsOrgConfig#identity_provider_id}
    */
    readonly identityProviderId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#org_id FederatedSettingsOrgConfig#org_id}
    */
    readonly orgId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#post_auth_role_grants FederatedSettingsOrgConfig#post_auth_role_grants}
    */
    readonly postAuthRoleGrants?: string[];
}
export interface FederatedSettingsOrgConfigUserConflicts {
}
export declare function federatedSettingsOrgConfigUserConflictsToTerraform(struct?: FederatedSettingsOrgConfigUserConflicts): any;
export declare function federatedSettingsOrgConfigUserConflictsToHclTerraform(struct?: FederatedSettingsOrgConfigUserConflicts): any;
export declare class FederatedSettingsOrgConfigUserConflictsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): FederatedSettingsOrgConfigUserConflicts | undefined;
    set internalValue(value: FederatedSettingsOrgConfigUserConflicts | undefined);
    get emailAddress(): string;
    get federationSettingsId(): string;
    get firstName(): string;
    get lastName(): string;
    get userId(): string;
}
export declare class FederatedSettingsOrgConfigUserConflictsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): FederatedSettingsOrgConfigUserConflictsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config mongodbatlas_federated_settings_org_config}
*/
export declare class FederatedSettingsOrgConfig extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_federated_settings_org_config";
    /**
    * Generates CDKTF code for importing a FederatedSettingsOrgConfig resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the FederatedSettingsOrgConfig to import
    * @param importFromId The id of the existing FederatedSettingsOrgConfig that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the FederatedSettingsOrgConfig to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/federated_settings_org_config mongodbatlas_federated_settings_org_config} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options FederatedSettingsOrgConfigConfig
    */
    constructor(scope: Construct, id: string, config: FederatedSettingsOrgConfigConfig);
    private _dataAccessIdentityProviderIds?;
    get dataAccessIdentityProviderIds(): string[];
    set dataAccessIdentityProviderIds(value: string[]);
    resetDataAccessIdentityProviderIds(): void;
    get dataAccessIdentityProviderIdsInput(): string[] | undefined;
    private _domainAllowList?;
    get domainAllowList(): string[];
    set domainAllowList(value: string[]);
    resetDomainAllowList(): void;
    get domainAllowListInput(): string[] | undefined;
    private _domainRestrictionEnabled?;
    get domainRestrictionEnabled(): boolean | cdktf.IResolvable;
    set domainRestrictionEnabled(value: boolean | cdktf.IResolvable);
    get domainRestrictionEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _federationSettingsId?;
    get federationSettingsId(): string;
    set federationSettingsId(value: string);
    get federationSettingsIdInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _identityProviderId?;
    get identityProviderId(): string;
    set identityProviderId(value: string);
    resetIdentityProviderId(): void;
    get identityProviderIdInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    private _postAuthRoleGrants?;
    get postAuthRoleGrants(): string[];
    set postAuthRoleGrants(value: string[]);
    resetPostAuthRoleGrants(): void;
    get postAuthRoleGrantsInput(): string[] | undefined;
    private _userConflicts;
    get userConflicts(): FederatedSettingsOrgConfigUserConflictsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
