/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface MaintenanceWindowConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#auto_defer MaintenanceWindow#auto_defer}
    */
    readonly autoDefer?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#auto_defer_once_enabled MaintenanceWindow#auto_defer_once_enabled}
    */
    readonly autoDeferOnceEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#day_of_week MaintenanceWindow#day_of_week}
    */
    readonly dayOfWeek: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#defer MaintenanceWindow#defer}
    */
    readonly defer?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#hour_of_day MaintenanceWindow#hour_of_day}
    */
    readonly hourOfDay?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#id MaintenanceWindow#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#project_id MaintenanceWindow#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#start_asap MaintenanceWindow#start_asap}
    */
    readonly startAsap?: boolean | cdktf.IResolvable;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window mongodbatlas_maintenance_window}
*/
export declare class MaintenanceWindow extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_maintenance_window";
    /**
    * Generates CDKTF code for importing a MaintenanceWindow resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the MaintenanceWindow to import
    * @param importFromId The id of the existing MaintenanceWindow that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the MaintenanceWindow to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/maintenance_window mongodbatlas_maintenance_window} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options MaintenanceWindowConfig
    */
    constructor(scope: Construct, id: string, config: MaintenanceWindowConfig);
    private _autoDefer?;
    get autoDefer(): boolean | cdktf.IResolvable;
    set autoDefer(value: boolean | cdktf.IResolvable);
    resetAutoDefer(): void;
    get autoDeferInput(): boolean | cdktf.IResolvable | undefined;
    private _autoDeferOnceEnabled?;
    get autoDeferOnceEnabled(): boolean | cdktf.IResolvable;
    set autoDeferOnceEnabled(value: boolean | cdktf.IResolvable);
    resetAutoDeferOnceEnabled(): void;
    get autoDeferOnceEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _dayOfWeek?;
    get dayOfWeek(): number;
    set dayOfWeek(value: number);
    get dayOfWeekInput(): number | undefined;
    private _defer?;
    get defer(): boolean | cdktf.IResolvable;
    set defer(value: boolean | cdktf.IResolvable);
    resetDefer(): void;
    get deferInput(): boolean | cdktf.IResolvable | undefined;
    private _hourOfDay?;
    get hourOfDay(): number;
    set hourOfDay(value: number);
    resetHourOfDay(): void;
    get hourOfDayInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get numberOfDeferrals(): number;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _startAsap?;
    get startAsap(): boolean | cdktf.IResolvable;
    set startAsap(value: boolean | cdktf.IResolvable);
    resetStartAsap(): void;
    get startAsapInput(): boolean | cdktf.IResolvable | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
