/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OnlineArchiveConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#cluster_name OnlineArchive#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#coll_name OnlineArchive#coll_name}
    */
    readonly collName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#collection_type OnlineArchive#collection_type}
    */
    readonly collectionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#db_name OnlineArchive#db_name}
    */
    readonly dbName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#id OnlineArchive#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#paused OnlineArchive#paused}
    */
    readonly paused?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#project_id OnlineArchive#project_id}
    */
    readonly projectId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#sync_creation OnlineArchive#sync_creation}
    */
    readonly syncCreation?: boolean | cdktf.IResolvable;
    /**
    * criteria block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#criteria OnlineArchive#criteria}
    */
    readonly criteria: OnlineArchiveCriteria;
    /**
    * data_expiration_rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#data_expiration_rule OnlineArchive#data_expiration_rule}
    */
    readonly dataExpirationRule?: OnlineArchiveDataExpirationRule;
    /**
    * data_process_region block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#data_process_region OnlineArchive#data_process_region}
    */
    readonly dataProcessRegion?: OnlineArchiveDataProcessRegion;
    /**
    * partition_fields block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#partition_fields OnlineArchive#partition_fields}
    */
    readonly partitionFields?: OnlineArchivePartitionFields[] | cdktf.IResolvable;
    /**
    * schedule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#schedule OnlineArchive#schedule}
    */
    readonly schedule?: OnlineArchiveSchedule;
}
export interface OnlineArchiveCriteria {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#date_field OnlineArchive#date_field}
    */
    readonly dateField?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#date_format OnlineArchive#date_format}
    */
    readonly dateFormat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#expire_after_days OnlineArchive#expire_after_days}
    */
    readonly expireAfterDays?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#query OnlineArchive#query}
    */
    readonly query?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#type OnlineArchive#type}
    */
    readonly type: string;
}
export declare function onlineArchiveCriteriaToTerraform(struct?: OnlineArchiveCriteriaOutputReference | OnlineArchiveCriteria): any;
export declare function onlineArchiveCriteriaToHclTerraform(struct?: OnlineArchiveCriteriaOutputReference | OnlineArchiveCriteria): any;
export declare class OnlineArchiveCriteriaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OnlineArchiveCriteria | undefined;
    set internalValue(value: OnlineArchiveCriteria | undefined);
    private _dateField?;
    get dateField(): string;
    set dateField(value: string);
    resetDateField(): void;
    get dateFieldInput(): string | undefined;
    private _dateFormat?;
    get dateFormat(): string;
    set dateFormat(value: string);
    resetDateFormat(): void;
    get dateFormatInput(): string | undefined;
    private _expireAfterDays?;
    get expireAfterDays(): number;
    set expireAfterDays(value: number);
    resetExpireAfterDays(): void;
    get expireAfterDaysInput(): number | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    resetQuery(): void;
    get queryInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface OnlineArchiveDataExpirationRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#expire_after_days OnlineArchive#expire_after_days}
    */
    readonly expireAfterDays: number;
}
export declare function onlineArchiveDataExpirationRuleToTerraform(struct?: OnlineArchiveDataExpirationRuleOutputReference | OnlineArchiveDataExpirationRule): any;
export declare function onlineArchiveDataExpirationRuleToHclTerraform(struct?: OnlineArchiveDataExpirationRuleOutputReference | OnlineArchiveDataExpirationRule): any;
export declare class OnlineArchiveDataExpirationRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OnlineArchiveDataExpirationRule | undefined;
    set internalValue(value: OnlineArchiveDataExpirationRule | undefined);
    private _expireAfterDays?;
    get expireAfterDays(): number;
    set expireAfterDays(value: number);
    get expireAfterDaysInput(): number | undefined;
}
export interface OnlineArchiveDataProcessRegion {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#cloud_provider OnlineArchive#cloud_provider}
    */
    readonly cloudProvider?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#region OnlineArchive#region}
    */
    readonly region?: string;
}
export declare function onlineArchiveDataProcessRegionToTerraform(struct?: OnlineArchiveDataProcessRegionOutputReference | OnlineArchiveDataProcessRegion): any;
export declare function onlineArchiveDataProcessRegionToHclTerraform(struct?: OnlineArchiveDataProcessRegionOutputReference | OnlineArchiveDataProcessRegion): any;
export declare class OnlineArchiveDataProcessRegionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OnlineArchiveDataProcessRegion | undefined;
    set internalValue(value: OnlineArchiveDataProcessRegion | undefined);
    private _cloudProvider?;
    get cloudProvider(): string;
    set cloudProvider(value: string);
    resetCloudProvider(): void;
    get cloudProviderInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
}
export interface OnlineArchivePartitionFields {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#field_name OnlineArchive#field_name}
    */
    readonly fieldName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#order OnlineArchive#order}
    */
    readonly order: number;
}
export declare function onlineArchivePartitionFieldsToTerraform(struct?: OnlineArchivePartitionFields | cdktf.IResolvable): any;
export declare function onlineArchivePartitionFieldsToHclTerraform(struct?: OnlineArchivePartitionFields | cdktf.IResolvable): any;
export declare class OnlineArchivePartitionFieldsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OnlineArchivePartitionFields | cdktf.IResolvable | undefined;
    set internalValue(value: OnlineArchivePartitionFields | cdktf.IResolvable | undefined);
    private _fieldName?;
    get fieldName(): string;
    set fieldName(value: string);
    get fieldNameInput(): string | undefined;
    get fieldType(): string;
    private _order?;
    get order(): number;
    set order(value: number);
    get orderInput(): number | undefined;
}
export declare class OnlineArchivePartitionFieldsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OnlineArchivePartitionFields[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OnlineArchivePartitionFieldsOutputReference;
}
export interface OnlineArchiveSchedule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#day_of_month OnlineArchive#day_of_month}
    */
    readonly dayOfMonth?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#day_of_week OnlineArchive#day_of_week}
    */
    readonly dayOfWeek?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#end_hour OnlineArchive#end_hour}
    */
    readonly endHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#end_minute OnlineArchive#end_minute}
    */
    readonly endMinute?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#start_hour OnlineArchive#start_hour}
    */
    readonly startHour?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#start_minute OnlineArchive#start_minute}
    */
    readonly startMinute?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#type OnlineArchive#type}
    */
    readonly type: string;
}
export declare function onlineArchiveScheduleToTerraform(struct?: OnlineArchiveScheduleOutputReference | OnlineArchiveSchedule): any;
export declare function onlineArchiveScheduleToHclTerraform(struct?: OnlineArchiveScheduleOutputReference | OnlineArchiveSchedule): any;
export declare class OnlineArchiveScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OnlineArchiveSchedule | undefined;
    set internalValue(value: OnlineArchiveSchedule | undefined);
    private _dayOfMonth?;
    get dayOfMonth(): number;
    set dayOfMonth(value: number);
    resetDayOfMonth(): void;
    get dayOfMonthInput(): number | undefined;
    private _dayOfWeek?;
    get dayOfWeek(): number;
    set dayOfWeek(value: number);
    resetDayOfWeek(): void;
    get dayOfWeekInput(): number | undefined;
    private _endHour?;
    get endHour(): number;
    set endHour(value: number);
    resetEndHour(): void;
    get endHourInput(): number | undefined;
    private _endMinute?;
    get endMinute(): number;
    set endMinute(value: number);
    resetEndMinute(): void;
    get endMinuteInput(): number | undefined;
    private _startHour?;
    get startHour(): number;
    set startHour(value: number);
    resetStartHour(): void;
    get startHourInput(): number | undefined;
    private _startMinute?;
    get startMinute(): number;
    set startMinute(value: number);
    resetStartMinute(): void;
    get startMinuteInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive mongodbatlas_online_archive}
*/
export declare class OnlineArchive extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_online_archive";
    /**
    * Generates CDKTF code for importing a OnlineArchive resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OnlineArchive to import
    * @param importFromId The id of the existing OnlineArchive that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OnlineArchive to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/online_archive mongodbatlas_online_archive} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OnlineArchiveConfig
    */
    constructor(scope: Construct, id: string, config: OnlineArchiveConfig);
    get archiveId(): string;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    private _collName?;
    get collName(): string;
    set collName(value: string);
    get collNameInput(): string | undefined;
    private _collectionType?;
    get collectionType(): string;
    set collectionType(value: string);
    resetCollectionType(): void;
    get collectionTypeInput(): string | undefined;
    private _dbName?;
    get dbName(): string;
    set dbName(value: string);
    get dbNameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _paused?;
    get paused(): boolean | cdktf.IResolvable;
    set paused(value: boolean | cdktf.IResolvable);
    resetPaused(): void;
    get pausedInput(): boolean | cdktf.IResolvable | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get state(): string;
    private _syncCreation?;
    get syncCreation(): boolean | cdktf.IResolvable;
    set syncCreation(value: boolean | cdktf.IResolvable);
    resetSyncCreation(): void;
    get syncCreationInput(): boolean | cdktf.IResolvable | undefined;
    private _criteria;
    get criteria(): OnlineArchiveCriteriaOutputReference;
    putCriteria(value: OnlineArchiveCriteria): void;
    get criteriaInput(): OnlineArchiveCriteria | undefined;
    private _dataExpirationRule;
    get dataExpirationRule(): OnlineArchiveDataExpirationRuleOutputReference;
    putDataExpirationRule(value: OnlineArchiveDataExpirationRule): void;
    resetDataExpirationRule(): void;
    get dataExpirationRuleInput(): OnlineArchiveDataExpirationRule | undefined;
    private _dataProcessRegion;
    get dataProcessRegion(): OnlineArchiveDataProcessRegionOutputReference;
    putDataProcessRegion(value: OnlineArchiveDataProcessRegion): void;
    resetDataProcessRegion(): void;
    get dataProcessRegionInput(): OnlineArchiveDataProcessRegion | undefined;
    private _partitionFields;
    get partitionFields(): OnlineArchivePartitionFieldsList;
    putPartitionFields(value: OnlineArchivePartitionFields[] | cdktf.IResolvable): void;
    resetPartitionFields(): void;
    get partitionFieldsInput(): cdktf.IResolvable | OnlineArchivePartitionFields[] | undefined;
    private _schedule;
    get schedule(): OnlineArchiveScheduleOutputReference;
    putSchedule(value: OnlineArchiveSchedule): void;
    resetSchedule(): void;
    get scheduleInput(): OnlineArchiveSchedule | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
