/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface PrivateEndpointRegionalModeConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#enabled PrivateEndpointRegionalMode#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#id PrivateEndpointRegionalMode#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#project_id PrivateEndpointRegionalMode#project_id}
    */
    readonly projectId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#timeouts PrivateEndpointRegionalMode#timeouts}
    */
    readonly timeouts?: PrivateEndpointRegionalModeTimeouts;
}
export interface PrivateEndpointRegionalModeTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#create PrivateEndpointRegionalMode#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#delete PrivateEndpointRegionalMode#delete}
    */
    readonly delete?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#update PrivateEndpointRegionalMode#update}
    */
    readonly update?: string;
}
export declare function privateEndpointRegionalModeTimeoutsToTerraform(struct?: PrivateEndpointRegionalModeTimeouts | cdktf.IResolvable): any;
export declare function privateEndpointRegionalModeTimeoutsToHclTerraform(struct?: PrivateEndpointRegionalModeTimeouts | cdktf.IResolvable): any;
export declare class PrivateEndpointRegionalModeTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): PrivateEndpointRegionalModeTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: PrivateEndpointRegionalModeTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _delete?;
    get delete(): string;
    set delete(value: string);
    resetDelete(): void;
    get deleteInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode mongodbatlas_private_endpoint_regional_mode}
*/
export declare class PrivateEndpointRegionalMode extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_private_endpoint_regional_mode";
    /**
    * Generates CDKTF code for importing a PrivateEndpointRegionalMode resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the PrivateEndpointRegionalMode to import
    * @param importFromId The id of the existing PrivateEndpointRegionalMode that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the PrivateEndpointRegionalMode to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/private_endpoint_regional_mode mongodbatlas_private_endpoint_regional_mode} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options PrivateEndpointRegionalModeConfig
    */
    constructor(scope: Construct, id: string, config: PrivateEndpointRegionalModeConfig);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): PrivateEndpointRegionalModeTimeoutsOutputReference;
    putTimeouts(value: PrivateEndpointRegionalModeTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | PrivateEndpointRegionalModeTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
