/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ProjectConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_collect_database_specifics_statistics_enabled Project#is_collect_database_specifics_statistics_enabled}
    */
    readonly isCollectDatabaseSpecificsStatisticsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_data_explorer_enabled Project#is_data_explorer_enabled}
    */
    readonly isDataExplorerEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_extended_storage_sizes_enabled Project#is_extended_storage_sizes_enabled}
    */
    readonly isExtendedStorageSizesEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_performance_advisor_enabled Project#is_performance_advisor_enabled}
    */
    readonly isPerformanceAdvisorEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_realtime_performance_panel_enabled Project#is_realtime_performance_panel_enabled}
    */
    readonly isRealtimePerformancePanelEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#is_schema_advisor_enabled Project#is_schema_advisor_enabled}
    */
    readonly isSchemaAdvisorEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#name Project#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#org_id Project#org_id}
    */
    readonly orgId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#project_owner_id Project#project_owner_id}
    */
    readonly projectOwnerId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#region_usage_restrictions Project#region_usage_restrictions}
    */
    readonly regionUsageRestrictions?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#tags Project#tags}
    */
    readonly tags?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#with_default_alerts_settings Project#with_default_alerts_settings}
    */
    readonly withDefaultAlertsSettings?: boolean | cdktf.IResolvable;
    /**
    * limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#limits Project#limits}
    */
    readonly limits?: ProjectLimits[] | cdktf.IResolvable;
    /**
    * teams block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#teams Project#teams}
    */
    readonly teams?: ProjectTeams[] | cdktf.IResolvable;
}
export interface ProjectIpAddressesServicesClusters {
}
export declare function projectIpAddressesServicesClustersToTerraform(struct?: ProjectIpAddressesServicesClusters): any;
export declare function projectIpAddressesServicesClustersToHclTerraform(struct?: ProjectIpAddressesServicesClusters): any;
export declare class ProjectIpAddressesServicesClustersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ProjectIpAddressesServicesClusters | undefined;
    set internalValue(value: ProjectIpAddressesServicesClusters | undefined);
    get clusterName(): string;
    get inbound(): string[];
    get outbound(): string[];
}
export declare class ProjectIpAddressesServicesClustersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ProjectIpAddressesServicesClustersOutputReference;
}
export interface ProjectIpAddressesServices {
}
export declare function projectIpAddressesServicesToTerraform(struct?: ProjectIpAddressesServices): any;
export declare function projectIpAddressesServicesToHclTerraform(struct?: ProjectIpAddressesServices): any;
export declare class ProjectIpAddressesServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ProjectIpAddressesServices | undefined;
    set internalValue(value: ProjectIpAddressesServices | undefined);
    private _clusters;
    get clusters(): ProjectIpAddressesServicesClustersList;
}
export interface ProjectIpAddresses {
}
export declare function projectIpAddressesToTerraform(struct?: ProjectIpAddresses): any;
export declare function projectIpAddressesToHclTerraform(struct?: ProjectIpAddresses): any;
export declare class ProjectIpAddressesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ProjectIpAddresses | undefined;
    set internalValue(value: ProjectIpAddresses | undefined);
    private _services;
    get services(): ProjectIpAddressesServicesOutputReference;
}
export interface ProjectLimits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#name Project#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#value Project#value}
    */
    readonly value: number;
}
export declare function projectLimitsToTerraform(struct?: ProjectLimits | cdktf.IResolvable): any;
export declare function projectLimitsToHclTerraform(struct?: ProjectLimits | cdktf.IResolvable): any;
export declare class ProjectLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ProjectLimits | cdktf.IResolvable | undefined;
    set internalValue(value: ProjectLimits | cdktf.IResolvable | undefined);
    get currentUsage(): number;
    get defaultLimit(): number;
    get maximumLimit(): number;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): number;
    set value(value: number);
    get valueInput(): number | undefined;
}
export declare class ProjectLimitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ProjectLimits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ProjectLimitsOutputReference;
}
export interface ProjectTeams {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#role_names Project#role_names}
    */
    readonly roleNames: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#team_id Project#team_id}
    */
    readonly teamId: string;
}
export declare function projectTeamsToTerraform(struct?: ProjectTeams | cdktf.IResolvable): any;
export declare function projectTeamsToHclTerraform(struct?: ProjectTeams | cdktf.IResolvable): any;
export declare class ProjectTeamsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ProjectTeams | cdktf.IResolvable | undefined;
    set internalValue(value: ProjectTeams | cdktf.IResolvable | undefined);
    private _roleNames?;
    get roleNames(): string[];
    set roleNames(value: string[]);
    get roleNamesInput(): string[] | undefined;
    private _teamId?;
    get teamId(): string;
    set teamId(value: string);
    get teamIdInput(): string | undefined;
}
export declare class ProjectTeamsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ProjectTeams[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ProjectTeamsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project mongodbatlas_project}
*/
export declare class Project extends cdktf.TerraformResource {
    static readonly tfResourceType = "mongodbatlas_project";
    /**
    * Generates CDKTF code for importing a Project resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the Project to import
    * @param importFromId The id of the existing Project that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the Project to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.21.1/docs/resources/project mongodbatlas_project} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ProjectConfig
    */
    constructor(scope: Construct, id: string, config: ProjectConfig);
    get clusterCount(): number;
    get created(): string;
    get id(): string;
    private _ipAddresses;
    get ipAddresses(): ProjectIpAddressesOutputReference;
    private _isCollectDatabaseSpecificsStatisticsEnabled?;
    get isCollectDatabaseSpecificsStatisticsEnabled(): boolean | cdktf.IResolvable;
    set isCollectDatabaseSpecificsStatisticsEnabled(value: boolean | cdktf.IResolvable);
    resetIsCollectDatabaseSpecificsStatisticsEnabled(): void;
    get isCollectDatabaseSpecificsStatisticsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isDataExplorerEnabled?;
    get isDataExplorerEnabled(): boolean | cdktf.IResolvable;
    set isDataExplorerEnabled(value: boolean | cdktf.IResolvable);
    resetIsDataExplorerEnabled(): void;
    get isDataExplorerEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isExtendedStorageSizesEnabled?;
    get isExtendedStorageSizesEnabled(): boolean | cdktf.IResolvable;
    set isExtendedStorageSizesEnabled(value: boolean | cdktf.IResolvable);
    resetIsExtendedStorageSizesEnabled(): void;
    get isExtendedStorageSizesEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isPerformanceAdvisorEnabled?;
    get isPerformanceAdvisorEnabled(): boolean | cdktf.IResolvable;
    set isPerformanceAdvisorEnabled(value: boolean | cdktf.IResolvable);
    resetIsPerformanceAdvisorEnabled(): void;
    get isPerformanceAdvisorEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isRealtimePerformancePanelEnabled?;
    get isRealtimePerformancePanelEnabled(): boolean | cdktf.IResolvable;
    set isRealtimePerformancePanelEnabled(value: boolean | cdktf.IResolvable);
    resetIsRealtimePerformancePanelEnabled(): void;
    get isRealtimePerformancePanelEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _isSchemaAdvisorEnabled?;
    get isSchemaAdvisorEnabled(): boolean | cdktf.IResolvable;
    set isSchemaAdvisorEnabled(value: boolean | cdktf.IResolvable);
    resetIsSchemaAdvisorEnabled(): void;
    get isSchemaAdvisorEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    private _projectOwnerId?;
    get projectOwnerId(): string;
    set projectOwnerId(value: string);
    resetProjectOwnerId(): void;
    get projectOwnerIdInput(): string | undefined;
    private _regionUsageRestrictions?;
    get regionUsageRestrictions(): string;
    set regionUsageRestrictions(value: string);
    resetRegionUsageRestrictions(): void;
    get regionUsageRestrictionsInput(): string | undefined;
    private _tags?;
    get tags(): {
        [key: string]: string;
    };
    set tags(value: {
        [key: string]: string;
    });
    resetTags(): void;
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _withDefaultAlertsSettings?;
    get withDefaultAlertsSettings(): boolean | cdktf.IResolvable;
    set withDefaultAlertsSettings(value: boolean | cdktf.IResolvable);
    resetWithDefaultAlertsSettings(): void;
    get withDefaultAlertsSettingsInput(): boolean | cdktf.IResolvable | undefined;
    private _limits;
    get limits(): ProjectLimitsList;
    putLimits(value: ProjectLimits[] | cdktf.IResolvable): void;
    resetLimits(): void;
    get limitsInput(): cdktf.IResolvable | ProjectLimits[] | undefined;
    private _teams;
    get teams(): ProjectTeamsList;
    putTeams(value: ProjectTeams[] | cdktf.IResolvable): void;
    resetTeams(): void;
    get teamsInput(): cdktf.IResolvable | ProjectTeams[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
